(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Arial", 24, L3, center, nohscroll, bold;
	fontset = subtitle, "Arial", 18, L2, center, nohscroll, bold;
	fontset = subsubtitle, "Arial", 14, L2, center, nohscroll, italic;
	fontset = section, "Arial", 14, L2, nohscroll, bold, grayBox;
	fontset = subsection, "Arial", 12, L2, nohscroll, bold, blackBox;
	fontset = subsubsection, "Arial", 10, L2, nohscroll, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L2, nohscroll;
	fontset = smalltext, "Arial", 10, L2, nohscroll;
	fontset = input, "Courier", 12, L2, nowordwrap, bold;
	fontset = output, "Courier", 12, L2, nowordwrap;
	fontset = message, "Courier", 12, L2, nowordwrap, R65535;
	fontset = print, "Courier", 12, L2, nowordwrap;
	fontset = info, "Courier", 12, L2, nowordwrap;
	fontset = postscript, "Courier", 12, L2, nowordwrap;
	fontset = name, "Arial", 10, L2, nowordwrap, nohscroll, italic, B65535;
	fontset = header, "Arial", 10, L2;
	fontset = footer, "Arial", 12, L2, center;
	fontset = help, "Arial", 10, L2, nohscroll;
	fontset = clipboard, "Arial", 12, L2;
	fontset = completions, "Arial", 12, L2, nowordwrap;
	fontset = graphics, "Times New Roman", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Arial", 12, L2, nowordwrap;
	fontset = special2, "Arial", 12, L2, center, nowordwrap;
	fontset = special3, "Arial", 12, L2, right, nowordwrap;
	fontset = special4, "Arial", 12, L2, nowordwrap;
	fontset = special5, "Arial", 12, L2, nowordwrap;
	fontset = leftheader, "Arial", 10, L2;
	fontset = leftfooter, "Arial", 12, L2, center;
	fontset = reserved1, "Times New Roman", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; preserveAspect; nohscroll; center; ]
Conversion of Mathematica \\
 Notebooks  to \LaTeXe
:[font = subsubtitle; inactive; preserveAspect; nohscroll; center; ]
by Jens-Peer Kuska
:[font = section; inactive; preserveAspect; nohscroll; ]
Reference
:[font = subsubsection; inactive; preserveAspect; nohscroll; ]
Title
:[font = text; inactive; preserveAspect; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 12; ]
Conversion of Mathematica Notebooks to \LaTeXe
:[font = subsubsection; inactive; preserveAspect; nohscroll; ]
Author 
:[font = text; inactive; preserveAspect; nohscroll; ]
\begin{flushleft}
Jens-Peer Kuska \\
e-mail: jpk@apex.mpe.FTA-Berlin.de \\

Ahrenshooperstr. 10 \\
13051 Berlin \\
Germany \\
\end{flushleft}
:[font = subsubsection; inactive; preserveAspect; nohscroll; ]
Summary
:[font = text; inactive; preserveAspect; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 12; ]
A program for the conversion of Mathematica 2.2 notebooks into \LaTeXe\ is presented. The Program \textsf{mnb2ltx} translates the markup offered by the different notebook cell styles into  \LaTeXe. Output cells that contain \TeX\ expressions are  displayed as typset formula, or the contents of all output cells can be converted into the corresponding \texttt{TeXForm} via MathLink. 
:[font = subsubsection; inactive; preserveAspect; nohscroll; ]
Mathematica Version
:[font = text; inactive; preserveAspect; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 12; ]
2.2
:[font = subsubsection; inactive; nohscroll; ]
Operating Systems
:[font = text; inactive; nohscroll; ]
Unix, OS/2, Windows 95
:[font = subsubsection; inactive; nohscroll; ]
Required Software
:[font = text; inactive; nohscroll; ]
\LaTeXe with \textsf{graphics}, \textsf{color} and \textsf{psnfss} packages,
DVI-driver that produces PostScript like \textsf{dvips}. \texttt{CWEB} 3.x if the source code needs to be changed. 
:[font = subsubsection; inactive; preserveAspect; startGroup; nohscroll; ]
Limitation
:[font = text; inactive; preserveAspect; endGroup; nohscroll; ]
Some older Mathematica for OS/2 Versions needs a recompilation with IBM C.
:[font = subsubsection; inactive; startGroup; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Arial"; fontSize = 10; ]
Program Version
:[font = text; inactive; endGroup; nohscroll; ]
1.0$\beta$
:[font = section; inactive; preserveAspect; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Arial"; fontSize = 14; ]
Introduction
:[font = text; inactive; preserveAspect; nohscroll; ]
The Mathematica notebook format has become more and more poular as a portable document format for texts about mathematics, physics and Mathematica. The praxis shows that the portability of the format is limited by the use of font changing, usage of non-ASCII characters and different fontsets of printers.

The output of Mathematica was designed  for an ASCII-terminal and not for typesetting. When the results become more complex, it is hard to read. The
conversion of the notebook format to a  typesetting system like \TeX\   
offers a lot of advantages.
\begin{itemize}
   \item  mathematical formulas can be displayed in the usual way
   \item  the textual markup offered by \LaTeXe\ can easily be changed by redefinition of the layout without re-processing of the notebook
  \item notebooks do not allow  to typeset formulas in ordinary text, using \TeX\ here will improve the texts related with Mathematica
\end{itemize}

In the text cells of the notebook the front end of Mathematica is only used as text editor to produce the input file for \LaTeXe.
:[font = subsection; inactive; preserveAspect; startGroup; nohscroll; ]
Example
:[font = text; inactive; endGroup; nohscroll; ]
This notebook serves as an example for the features included in
\mnbtoltx. We can at first try to produce a mathematical expression by\footnote{This and the next cell are initialization cells and \mnbtoltx\ will detect this}:
:[font = input; initialization; startGroup; nowordwrap; ]
*)
fun=Integrate[Exp[-alpha*x]*Sin[lambda*x],x] //Simplify
(*
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
-((lambda*Cos[lambda*x] + alpha*Sin[lambda*x])/
    (E^(alpha*x)*(alpha^2 + lambda^2)))













;[o]
  lambda Cos[lambda x] + alpha Sin[lambda x]
-(------------------------------------------)
          alpha x       2         2
         E        (alpha  + lambda )
:[font = text; inactive; nohscroll; ]
This expression is still readable but 
:[font = input; initialization; startGroup; nowordwrap; ]
*)
% // TeXForm
(*
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}













;[o]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}
:[font = text; inactive; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 12; ]
will look mutch better. \mnbtoltx\ will usualy find input cells that are starting with
:[font = input; startGroup; nowordwrap; ]
TeXForm[%]
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}





























;[o]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}
:[font = text; inactive; nohscroll; ]
or 
:[font = input; startGroup; nowordwrap; ]
TeXForm @ %
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}
























;[o]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}
:[font = text; inactive; nohscroll; ]
The program will not detect \TeX-expressions in output cells if a function other than \texttt{TeXForm} returns a \TeX-string and so
:[font = input; nowordwrap; ]
MyTeXForm[a_]:=TeXForm[a]
:[font = text; inactive; nohscroll; ]
will reproduce still the original output in the \TeX-file
:[font = input; startGroup; nowordwrap; ]
MyTeXForm[fun]
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}
























;[o]
-{{\lambda \,\cos (\lambda \,x) + \alpha \,\sin (\lambda \,x)}\over 
    {{e^{\alpha \,x}}\,\left( {{\alpha }^2} + {{\lambda }^2} \right) }}
:[font = text; inactive; nohscroll; ]
An important point in a notebook are the visualisation of formulas by means of one or two dimensional graphics. \mnbtoltx\ is able to export the graphics as separate PostScript files.
:[font = input; startGroup; nowordwrap; ]
pic1=Plot[
       Evaluate[
         fun /. 
          {
           alpha->1,
           lambda->2}
        ],
       {x,0,2Pi},
       PlotRange->All
      ];
:[font = postscript; inactive; output; endGroup; BITMAP; PostScript; pictureLeft = 100; pictureTop = 0; pictureWidth = 300; pictureHeight = 185; nowordwrap; ]
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 12  scalefont  setfont
% Scaling calculations
0.0238095 0.151576 0.502018 1.21826 [
[(0)] .02381 0 0 2 Msboxa
[(1)] .17539 0 0 2 Msboxa
[(2)] .32696 0 0 2 Msboxa
[(3)] .47854 0 0 2 Msboxa
[(4)] .63011 0 0 2 Msboxa
[(5)] .78169 0 0 2 Msboxa
[(6)] .93327 0 0 2 Msboxa
[(-0.4)] -0.0125 .01472 1 0 Msboxa
[(-0.3)] -0.0125 .13654 1 0 Msboxa
[(-0.2)] -0.0125 .25837 1 0 Msboxa
[(-0.1)] -0.0125 .38019 1 0 Msboxa
[(0)] -0.0125 .50202 1 0 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.02381 0 m
.02381 .00625 L
s
P
[(0)] .02381 0 0 2 Mshowa
p
.002 w
.17539 0 m
.17539 .00625 L
s
P
[(1)] .17539 0 0 2 Mshowa
p
.002 w
.32696 0 m
.32696 .00625 L
s
P
[(2)] .32696 0 0 2 Mshowa
p
.002 w
.47854 0 m
.47854 .00625 L
s
P
[(3)] .47854 0 0 2 Mshowa
p
.002 w
.63011 0 m
.63011 .00625 L
s
P
[(4)] .63011 0 0 2 Mshowa
p
.002 w
.78169 0 m
.78169 .00625 L
s
P
[(5)] .78169 0 0 2 Mshowa
p
.002 w
.93327 0 m
.93327 .00625 L
s
P
[(6)] .93327 0 0 2 Mshowa
p
.001 w
.05412 0 m
.05412 .00375 L
s
P
p
.001 w
.08444 0 m
.08444 .00375 L
s
P
p
.001 w
.11476 0 m
.11476 .00375 L
s
P
p
.001 w
.14507 0 m
.14507 .00375 L
s
P
p
.001 w
.2057 0 m
.2057 .00375 L
s
P
p
.001 w
.23602 0 m
.23602 .00375 L
s
P
p
.001 w
.26633 0 m
.26633 .00375 L
s
P
p
.001 w
.29665 0 m
.29665 .00375 L
s
P
p
.001 w
.35728 0 m
.35728 .00375 L
s
P
p
.001 w
.38759 0 m
.38759 .00375 L
s
P
p
.001 w
.41791 0 m
.41791 .00375 L
s
P
p
.001 w
.44822 0 m
.44822 .00375 L
s
P
p
.001 w
.50885 0 m
.50885 .00375 L
s
P
p
.001 w
.53917 0 m
.53917 .00375 L
s
P
p
.001 w
.56948 0 m
.56948 .00375 L
s
P
p
.001 w
.5998 0 m
.5998 .00375 L
s
P
p
.001 w
.66043 0 m
.66043 .00375 L
s
P
p
.001 w
.69074 0 m
.69074 .00375 L
s
P
p
.001 w
.72106 0 m
.72106 .00375 L
s
P
p
.001 w
.75137 0 m
.75137 .00375 L
s
P
p
.001 w
.81201 0 m
.81201 .00375 L
s
P
p
.001 w
.84232 0 m
.84232 .00375 L
s
P
p
.001 w
.87264 0 m
.87264 .00375 L
s
P
p
.001 w
.90295 0 m
.90295 .00375 L
s
P
p
.001 w
.96358 0 m
.96358 .00375 L
s
P
p
.001 w
.9939 0 m
.9939 .00375 L
s
P
p
.002 w
0 0 m
1 0 L
s
P
p
.002 w
0 .01472 m
.00625 .01472 L
s
P
[(-0.4)] -0.0125 .01472 1 0 Mshowa
p
.002 w
0 .13654 m
.00625 .13654 L
s
P
[(-0.3)] -0.0125 .13654 1 0 Mshowa
p
.002 w
0 .25837 m
.00625 .25837 L
s
P
[(-0.2)] -0.0125 .25837 1 0 Mshowa
p
.002 w
0 .38019 m
.00625 .38019 L
s
P
[(-0.1)] -0.0125 .38019 1 0 Mshowa
p
.002 w
0 .50202 m
.00625 .50202 L
s
P
[(0)] -0.0125 .50202 1 0 Mshowa
p
.001 w
0 .03908 m
.00375 .03908 L
s
P
p
.001 w
0 .06345 m
.00375 .06345 L
s
P
p
.001 w
0 .08781 m
.00375 .08781 L
s
P
p
.001 w
0 .11218 m
.00375 .11218 L
s
P
p
.001 w
0 .16091 m
.00375 .16091 L
s
P
p
.001 w
0 .18527 m
.00375 .18527 L
s
P
p
.001 w
0 .20964 m
.00375 .20964 L
s
P
p
.001 w
0 .234 m
.00375 .234 L
s
P
p
.001 w
0 .28273 m
.00375 .28273 L
s
P
p
.001 w
0 .3071 m
.00375 .3071 L
s
P
p
.001 w
0 .33146 m
.00375 .33146 L
s
P
p
.001 w
0 .35583 m
.00375 .35583 L
s
P
p
.001 w
0 .40456 m
.00375 .40456 L
s
P
p
.001 w
0 .42892 m
.00375 .42892 L
s
P
p
.001 w
0 .45329 m
.00375 .45329 L
s
P
p
.001 w
0 .47765 m
.00375 .47765 L
s
P
p
.001 w
0 .52638 m
.00375 .52638 L
s
P
p
.001 w
0 .55075 m
.00375 .55075 L
s
P
p
.001 w
0 .57511 m
.00375 .57511 L
s
P
p
.001 w
0 .59948 m
.00375 .59948 L
s
P
p
.002 w
0 0 m
0 .61803 L
s
P
P
p
p
.002 w
.02381 .61178 m
.02381 .61803 L
s
P
p
.002 w
.17539 .61178 m
.17539 .61803 L
s
P
p
.002 w
.32696 .61178 m
.32696 .61803 L
s
P
p
.002 w
.47854 .61178 m
.47854 .61803 L
s
P
p
.002 w
.63011 .61178 m
.63011 .61803 L
s
P
p
.002 w
.78169 .61178 m
.78169 .61803 L
s
P
p
.002 w
.93327 .61178 m
.93327 .61803 L
s
P
p
.001 w
.05412 .61428 m
.05412 .61803 L
s
P
p
.001 w
.08444 .61428 m
.08444 .61803 L
s
P
p
.001 w
.11476 .61428 m
.11476 .61803 L
s
P
p
.001 w
.14507 .61428 m
.14507 .61803 L
s
P
p
.001 w
.2057 .61428 m
.2057 .61803 L
s
P
p
.001 w
.23602 .61428 m
.23602 .61803 L
s
P
p
.001 w
.26633 .61428 m
.26633 .61803 L
s
P
p
.001 w
.29665 .61428 m
.29665 .61803 L
s
P
p
.001 w
.35728 .61428 m
.35728 .61803 L
s
P
p
.001 w
.38759 .61428 m
.38759 .61803 L
s
P
p
.001 w
.41791 .61428 m
.41791 .61803 L
s
P
p
.001 w
.44822 .61428 m
.44822 .61803 L
s
P
p
.001 w
.50885 .61428 m
.50885 .61803 L
s
P
p
.001 w
.53917 .61428 m
.53917 .61803 L
s
P
p
.001 w
.56948 .61428 m
.56948 .61803 L
s
P
p
.001 w
.5998 .61428 m
.5998 .61803 L
s
P
p
.001 w
.66043 .61428 m
.66043 .61803 L
s
P
p
.001 w
.69074 .61428 m
.69074 .61803 L
s
P
p
.001 w
.72106 .61428 m
.72106 .61803 L
s
P
p
.001 w
.75137 .61428 m
.75137 .61803 L
s
P
p
.001 w
.81201 .61428 m
.81201 .61803 L
s
P
p
.001 w
.84232 .61428 m
.84232 .61803 L
s
P
p
.001 w
.87264 .61428 m
.87264 .61803 L
s
P
p
.001 w
.90295 .61428 m
.90295 .61803 L
s
P
p
.001 w
.96358 .61428 m
.96358 .61803 L
s
P
p
.001 w
.9939 .61428 m
.9939 .61803 L
s
P
p
.002 w
0 .61803 m
1 .61803 L
s
P
p
.002 w
.99375 .01472 m
1 .01472 L
s
P
p
.002 w
.99375 .13654 m
1 .13654 L
s
P
p
.002 w
.99375 .25837 m
1 .25837 L
s
P
p
.002 w
.99375 .38019 m
1 .38019 L
s
P
p
.002 w
.99375 .50202 m
1 .50202 L
s
P
p
.001 w
.99625 .03908 m
1 .03908 L
s
P
p
.001 w
.99625 .06345 m
1 .06345 L
s
P
p
.001 w
.99625 .08781 m
1 .08781 L
s
P
p
.001 w
.99625 .11218 m
1 .11218 L
s
P
p
.001 w
.99625 .16091 m
1 .16091 L
s
P
p
.001 w
.99625 .18527 m
1 .18527 L
s
P
p
.001 w
.99625 .20964 m
1 .20964 L
s
P
p
.001 w
.99625 .234 m
1 .234 L
s
P
p
.001 w
.99625 .28273 m
1 .28273 L
s
P
p
.001 w
.99625 .3071 m
1 .3071 L
s
P
p
.001 w
.99625 .33146 m
1 .33146 L
s
P
p
.001 w
.99625 .35583 m
1 .35583 L
s
P
p
.001 w
.99625 .40456 m
1 .40456 L
s
P
p
.001 w
.99625 .42892 m
1 .42892 L
s
P
p
.001 w
.99625 .45329 m
1 .45329 L
s
P
p
.001 w
.99625 .47765 m
1 .47765 L
s
P
p
.001 w
.99625 .52638 m
1 .52638 L
s
P
p
.001 w
.99625 .55075 m
1 .55075 L
s
P
p
.001 w
.99625 .57511 m
1 .57511 L
s
P
p
.001 w
.99625 .59948 m
1 .59948 L
s
P
p
.002 w
1 0 m
1 .61803 L
s
P
P
p
p
.002 w
0 .50202 m
1 .50202 L
s
P
P
p
p
.004 w
.02381 .01472 m
.02505 .0148 L
.02629 .01504 L
.02753 .01544 L
.02877 .01599 L
.03001 .0167 L
.03125 .01755 L
.03373 .0197 L
.03869 .02568 L
.04365 .03375 L
.05357 .05545 L
.06349 .08344 L
.10317 .23268 L
.14286 .39093 L
.1627 .45833 L
.18254 .51347 L
.19246 .53599 L
.20238 .55506 L
.2123 .57073 L
.22222 .5831 L
.22718 .58809 L
.23214 .59232 L
.2371 .59582 L
.24206 .59861 L
.24454 .59975 L
.24702 .60072 L
.2495 .60153 L
.25198 .60219 L
.25322 .60246 L
.25446 .60269 L
.2557 .60288 L
.25694 .60304 L
.25818 .60316 L
.25942 .60325 L
.26066 .6033 L
.2619 .60332 L
.26314 .6033 L
.26438 .60325 L
.26562 .60317 L
.26687 .60305 L
.26935 .60273 L
.27183 .60228 L
.27679 .60104 L
.28175 .59936 L
.29167 .59485 L
.30159 .58903 L
.34127 .55801 L
.38095 .52511 L
.40079 .5111 L
.42063 .49964 L
Mistroke
.43056 .49496 L
.44048 .49099 L
.4504 .48774 L
.46032 .48516 L
.46528 .48413 L
.47024 .48325 L
.4752 .48252 L
.48016 .48194 L
.48264 .4817 L
.48512 .4815 L
.4876 .48133 L
.49008 .4812 L
.49132 .48114 L
.49256 .48109 L
.4938 .48105 L
.49504 .48102 L
.49628 .48099 L
.49752 .48097 L
.49876 .48096 L
.5 .48096 L
.50124 .48096 L
.50248 .48097 L
.50372 .48099 L
.50496 .48102 L
.5062 .48105 L
.50744 .48108 L
.50992 .48118 L
.51488 .48143 L
.51984 .48178 L
.52976 .48272 L
.53968 .48393 L
.57937 .49038 L
.61905 .49722 L
.63889 .50013 L
.65873 .50251 L
.66865 .50349 L
.67857 .50431 L
.68849 .50499 L
.69841 .50552 L
.70337 .50574 L
.70833 .50592 L
.71329 .50607 L
.71825 .50619 L
.72073 .50624 L
.72321 .50628 L
.72569 .50632 L
.72817 .50635 L
.72941 .50636 L
.73065 .50637 L
.73189 .50638 L
Mistroke
.73313 .50638 L
.73437 .50639 L
.73562 .50639 L
.73686 .5064 L
.7381 .5064 L
.73934 .5064 L
.74058 .50639 L
.74182 .50639 L
.74306 .50638 L
.74554 .50637 L
.74802 .50635 L
.75298 .5063 L
.75794 .50623 L
.76786 .50603 L
.77778 .50578 L
.81746 .50444 L
.85714 .50302 L
.87698 .50241 L
.89683 .50192 L
.90675 .50171 L
.91667 .50154 L
.92659 .5014 L
.93651 .50129 L
.94147 .50125 L
.94643 .50121 L
.95139 .50118 L
.95635 .50115 L
.95883 .50114 L
.96131 .50113 L
.96379 .50112 L
.96627 .50112 L
.96751 .50112 L
.96875 .50111 L
.96999 .50111 L
.97123 .50111 L
.97247 .50111 L
.97371 .50111 L
.97495 .50111 L
.97619 .50111 L
Mfstroke
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
:[font = input; startGroup; nowordwrap; ]
pic2=Plot3D[
       Evaluate[
         fun /. alpha->1
        ], 
       {x,0,Pi},{lambda,0,Pi}]
:[font = postscript; inactive; output; BITMAP; PostScript; pictureLeft = 100; pictureTop = 0; pictureWidth = 300; pictureHeight = 246; nowordwrap; ]
%!
%%Creator: Mathematica
%%AspectRatio: .82055 
MathPictureStart
%% SurfaceGraphics
/Courier findfont 12  scalefont  setfont
% Scaling calculations
0.0249355 0.99742 -0.0396341 0.99742 [
[(0)] .05113 .25884 1 .93395 Msboxa
[(1)] .23273 .18737 .938 1 Msboxa
[(2)] .42876 .11027 .80527 1 Msboxa
[(3)] .64102 .02686 .67254 1 Msboxa
[(0)] .69093 .02039 -1 .39157 Msboxa
[(1)] .78883 .17029 -1 .35729 Msboxa
[(2)] .87374 .30032 -1 .32852 Msboxa
[(3)] .94809 .41419 -1 .30405 Msboxa
[(-0.4)] .0427 .30909 1 -0.38422 Msboxa
[(-0.2)] .03173 .37786 1 -0.37058 Msboxa
[(0)] .02023 .4499 1 -0.35623 Msboxa
[ 0 0 0 0 ]
[ 1 .82055 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.06024 .26735 m
.67932 .02494 L
s
P
p
.002 w
.06024 .26735 m
.0648 .2716 L
s
P
[(0)] .05113 .25884 1 .93395 Mshowa
p
.002 w
.24126 .19647 m
.24553 .20101 L
s
P
[(1)] .23273 .18737 .938 1 Mshowa
p
.002 w
.43658 .11999 m
.44049 .12484 L
s
P
[(2)] .42876 .11027 .80527 1 Mshowa
p
.002 w
.64798 .03721 m
.65146 .04238 L
s
P
[(3)] .64102 .02686 .67254 1 Mshowa
p
.001 w
.09538 .25359 m
.09808 .25618 L
s
P
p
.001 w
.13104 .23963 m
.1337 .24225 L
s
P
p
.001 w
.16723 .22546 m
.16986 .22811 L
s
P
p
.001 w
.20396 .21107 m
.20656 .21376 L
s
P
p
.001 w
.27913 .18164 m
.28165 .1844 L
s
P
p
.001 w
.31758 .16658 m
.32006 .16938 L
s
P
p
.001 w
.35663 .15129 m
.35907 .15413 L
s
P
p
.001 w
.39629 .13576 m
.39869 .13864 L
s
P
p
.001 w
.47752 .10396 m
.47981 .10691 L
s
P
p
.001 w
.5191 .08767 m
.52135 .09066 L
s
P
p
.001 w
.56137 .07112 m
.56356 .07415 L
s
P
p
.001 w
.60432 .05431 m
.60646 .05737 L
s
P
P
p
p
.002 w
.67932 .02494 m
.94594 .43277 L
s
P
p
.002 w
.67932 .02494 m
.67352 .02721 L
s
P
[(0)] .69093 .02039 -1 .39157 Mshowa
p
.002 w
.77709 .17448 m
.77122 .17658 L
s
P
[(1)] .78883 .17029 -1 .35729 Mshowa
p
.002 w
.8619 .30421 m
.85598 .30616 L
s
P
[(2)] .87374 .30032 -1 .32852 Mshowa
p
.002 w
.93616 .41781 m
.9302 .41963 L
s
P
[(3)] .94809 .41419 -1 .30405 Mshowa
p
.001 w
.70005 .05665 m
.69656 .05799 L
s
P
p
.001 w
.72017 .08742 m
.71667 .08874 L
s
P
p
.001 w
.7397 .11729 m
.73619 .11858 L
s
P
p
.001 w
.75866 .1463 m
.75515 .14758 L
s
P
p
.001 w
.795 .20188 m
.79147 .20312 L
s
P
p
.001 w
.81242 .22852 m
.80888 .22974 L
s
P
p
.001 w
.82936 .25444 m
.82582 .25564 L
s
P
p
.001 w
.84585 .27966 m
.8423 .28084 L
s
P
p
.001 w
.87753 .32812 m
.87397 .32927 L
s
P
p
.001 w
.89276 .35141 m
.88919 .35255 L
s
P
p
.001 w
.90759 .37411 m
.90402 .37523 L
s
P
p
.001 w
.92206 .39624 m
.91849 .39734 L
s
P
P
p
p
.002 w
.06024 .26735 m
.02494 .49015 L
s
P
p
.002 w
.05434 .30462 m
.06015 .30239 L
s
P
[(-0.4)] .0427 .30909 1 -0.38422 Mshowa
p
.002 w
.04342 .37353 m
.04926 .37136 L
s
P
[(-0.2)] .03173 .37786 1 -0.37058 Mshowa
p
.002 w
.03198 .44572 m
.03785 .44363 L
s
P
[(0)] .02023 .4499 1 -0.35623 Mshowa
p
.001 w
.05219 .31815 m
.05569 .31682 L
s
P
p
.001 w
.05003 .3318 m
.05353 .33048 L
s
P
p
.001 w
.04784 .34558 m
.05135 .34427 L
s
P
p
.001 w
.04564 .35949 m
.04914 .35818 L
s
P
p
.001 w
.04117 .3877 m
.04468 .3864 L
s
P
p
.001 w
.0389 .402 m
.04242 .40071 L
s
P
p
.001 w
.03662 .41643 m
.04013 .41516 L
s
P
p
.001 w
.03431 .43101 m
.03783 .42974 L
s
P
p
.001 w
.05646 .29121 m
.05995 .28986 L
s
P
p
.001 w
.05857 .27793 m
.06205 .27657 L
s
P
p
.001 w
.02962 .46057 m
.03315 .45932 L
s
P
p
.001 w
.02725 .47557 m
.03078 .47433 L
s
P
P
0 0 m
1 0 L
1 .82055 L
0 .82055 L
closepath
clip
newpath
p
.002 w
.06024 .26735 m
.02494 .49015 L
s
.02494 .49015 m
.40296 .79562 L
s
.40296 .79562 m
.41001 .59401 L
s
.41001 .59401 m
.06024 .26735 L
s
.67932 .02494 m
.94594 .43277 L
s
.94594 .43277 m
.97506 .64585 L
s
.97506 .64585 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.06024 .26735 m
.02494 .49015 L
s
.02494 .49015 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.67932 .02494 m
.06024 .26735 L
s
.41001 .59401 m
.94594 .43277 L
s
.94594 .43277 m
.97506 .64585 L
s
.97506 .64585 m
.40296 .79562 L
s
.40296 .79562 m
.41001 .59401 L
s
P
p
.375 .58 .921 r
.0015 w
.3865 .63797 .40762 .66258 .44272 .67311 .42177 .6469 Metetra
0 .181 .705 r
.42177 .6469 .44272 .67311 .47846 .70694 .45751 .67862 Metetra
0 .237 .752 r
.45751 .67862 .47846 .70694 .5157 .73802 .49473 .71021 Metetra
.283 .509 .897 r
.49473 .71021 .5157 .73802 .55425 .74957 .53343 .72592 Metetra
.589 .699 .919 r
.53343 .72592 .55425 .74957 .59341 .73878 .57302 .7211 Metetra
.735 .801 .904 r
.57302 .7211 .59341 .73878 .63269 .71367 .61295 .70065 Metetra
.788 .859 .903 r
.61295 .70065 .63269 .71367 .6721 .68555 .653 .67375 Metetra
.775 .877 .921 r
.653 .67375 .6721 .68555 .71199 .66277 .69339 .64857 Metetra
.719 .847 .942 r
.69339 .64857 .71199 .66277 .75279 .64828 .73446 .62957 Metetra
.654 .783 .942 r
.73446 .62957 .75279 .64828 .7947 .64047 .7765 .61724 Metetra
.613 .724 .925 r
.7765 .61724 .7947 .64047 .83761 .63544 .81961 .6094 Metetra
.602 .697 .91 r
.81961 .6094 .83761 .63544 .88128 .62947 .86366 .60295 Metetra
.613 .7 .906 r
.86366 .60295 .88128 .62947 .92542 .62042 .90843 .59528 Metetra
.633 .724 .914 r
.90843 .59528 .92542 .62042 .96991 .60816 .95374 .58509 Metetra
.412 .592 .917 r
.36494 .61221 .3865 .63797 .42177 .6469 .40037 .61948 Metetra
0 .239 .752 r
.40037 .61948 .42177 .6469 .45751 .67862 .43614 .64879 Metetra
0 .246 .76 r
.43614 .64879 .45751 .67862 .49473 .71021 .47332 .68018 Metetra
.23 .464 .877 r
.47332 .68018 .49473 .71021 .53343 .72592 .51209 .69923 Metetra
.521 .649 .915 r
.51209 .69923 .53343 .72592 .57302 .7211 .55202 .70016 Metetra
.685 .764 .912 r
.55202 .70016 .57302 .7211 .61295 .70065 .59251 .68525 Metetra
.761 .837 .91 r
.59251 .68525 .61295 .70065 .653 .67375 .63326 .6613 Metetra
.775 .874 .92 r
.63326 .6613 .653 .67375 .69339 .64857 .67425 .63564 Metetra
.745 .871 .938 r
.67425 .63564 .69339 .64857 .73446 .62957 .71574 .61337 Metetra
.693 .828 .948 r
.71574 .61337 .73446 .62957 .7765 .61724 .75803 .59659 Metetra
.645 .768 .938 r
.75803 .59659 .7765 .61724 .81961 .6094 .8013 .5848 Metetra
.618 .722 .921 r
.8013 .5848 .81961 .6094 .86366 .60295 .8456 .57604 Metetra
.612 .703 .909 r
.8456 .57604 .86366 .60295 .90843 .59528 .89081 .56803 Metetra
.621 .707 .907 r
.89081 .56803 .90843 .59528 .95374 .58509 .93677 .55898 Metetra
.446 .602 .912 r
.34293 .58521 .36494 .61221 .40037 .61948 .37854 .59078 Metetra
0 .298 .794 r
.37854 .59078 .40037 .61948 .43614 .64879 .41435 .61739 Metetra
0 .267 .774 r
.41435 .61739 .43614 .64879 .47332 .68018 .45148 .64784 Metetra
.198 .43 .859 r
.45148 .64784 .47332 .68018 .51209 .69923 .49027 .66928 Metetra
.457 .597 .903 r
.49027 .66928 .51209 .69923 .55202 .70016 .53041 .6754 Metetra
.626 .717 .912 r
.53041 .6754 .55202 .70016 .59251 .68525 .57139 .66642 Metetra
.721 .802 .915 r
.57139 .66642 .59251 .68525 .63326 .6613 .61279 .64688 Metetra
.759 .857 .922 r
.61279 .64688 .63326 .6613 .67425 .63564 .65448 .62273 Metetra
.754 .877 .935 r
.65448 .62273 .67425 .63564 .71574 .61337 .69655 .59902 Metetra
.72 .86 .948 r
.69655 .59902 .71574 .61337 .75803 .59659 .73923 .57875 Metetra
.679 .816 .949 r
.73923 .57875 .75803 .59659 .8013 .5848 .78275 .56283 Metetra
.645 .765 .936 r
.78275 .56283 .8013 .5848 .8456 .57604 .82725 .55056 Metetra
.626 .727 .92 r
.82725 .55056 .8456 .57604 .89081 .56803 .87275 .54046 Metetra
.621 .71 .91 r
.87275 .54046 .89081 .56803 .93677 .55898 .91917 .5309 Metetra
.476 .61 .905 r
.32046 .55693 .34293 .58521 .37854 .59078 .35626 .56074 Metetra
.05 .356 .829 r
.35626 .56074 .37854 .59078 .41435 .61739 .39214 .58437 Metetra
0 .298 .793 r
.39214 .58437 .41435 .61739 .45148 .64784 .42924 .61317 Metetra
.187 .41 .847 r
.42924 .61317 .45148 .64784 .49027 .66928 .46799 .63593 Metetra
.405 .549 .886 r
.46799 .63593 .49027 .66928 .53041 .6754 .50825 .64635 Metetra
.566 .663 .903 r
.50825 .64635 .53041 .6754 .57139 .66642 .54958 .64319 Metetra
.67 .753 .913 r
.54958 .64319 .57139 .66642 .61279 .64688 .59158 .62901 Metetra
.727 .822 .924 r
.59158 .62901 .61279 .64688 .65448 .62273 .63397 .60818 Metetra
.745 .863 .935 r
.63397 .60818 .65448 .62273 .69655 .59902 .67673 .5851 Metetra
.732 .873 .946 r
.67673 .5851 .69655 .59902 .73923 .57875 .71997 .56306 Metetra
.704 .852 .953 r
.71997 .56306 .73923 .57875 .78275 .56283 .7639 .54383 Metetra
.673 .812 .95 r
.7639 .54383 .78275 .56283 .82725 .55056 .80868 .52783 Metetra
.649 .769 .937 r
.80868 .52783 .82725 .55056 .87275 .54046 .85443 .51453 Metetra
.634 .737 .922 r
.85443 .51453 .87275 .54046 .91917 .5309 .90117 .50287 Metetra
.502 .617 .898 r
.29754 .52736 .32046 .55693 .35626 .56074 .33355 .52937 Metetra
.143 .409 .855 r
.33355 .52937 .35626 .56074 .39214 .58437 .36953 .54976 Metetra
.065 .336 .813 r
.36953 .54976 .39214 .58437 .42924 .61317 .40662 .57622 Metetra
.197 .405 .839 r
.40662 .57622 .42924 .61317 .46799 .63593 .4453 .59917 Metetra
.37 .511 .869 r
.4453 .59917 .46799 .63593 .50825 .64635 .48558 .61271 Metetra
.512 .61 .887 r
.48558 .61271 .50825 .64635 .54958 .64319 .52715 .61474 Metetra
.614 .696 .902 r
.52715 .61474 .54958 .64319 .59158 .62901 .56961 .60624 Metetra
.682 .77 .918 r
.56961 .60624 .59158 .62901 .63397 .60818 .61266 .59004 Metetra
.718 .827 .933 r
.61266 .59004 .63397 .60818 .67673 .5851 .65615 .56956 Metetra
.726 .86 .945 r
.65615 .56956 .67673 .5851 .71997 .56306 .7001 .54782 Metetra
.714 .865 .953 r
.7001 .54782 .71997 .56306 .7639 .54383 .74461 .52695 Metetra
.693 .847 .957 r
.74461 .52695 .7639 .54383 .80868 .52783 .78984 .50809 Metetra
.672 .815 .952 r
.78984 .50809 .80868 .52783 .85443 .51453 .83593 .4915 Metetra
.654 .78 .94 r
.83593 .4915 .85443 .51453 .90117 .50287 .88297 .47686 Metetra
.526 .624 .891 r
.27416 .49663 .29754 .52736 .33355 .52937 .31039 .49679 Metetra
.229 .457 .872 r
.31039 .49679 .33355 .52937 .36953 .54976 .34651 .51372 Metetra
.14 .377 .832 r
.34651 .51372 .36953 .54976 .40662 .57622 .38362 .53717 Metetra
.224 .411 .837 r
.38362 .53717 .40662 .57622 .4453 .59917 .42224 .55916 Metetra
.355 .486 .853 r
.42224 .55916 .4453 .59917 .48558 .61271 .46249 .57444 Metetra
.472 .564 .867 r
.46249 .57444 .48558 .61271 .52715 .61474 .50416 .58053 Metetra
.564 .638 .883 r
.50416 .58053 .52715 .61474 .56961 .60624 .54694 .57733 Metetra
.632 .708 .901 r
.54694 .57733 .56961 .60624 .61266 .59004 .59052 .56637 Metetra
.678 .771 .921 r
.59052 .56637 .61266 .59004 .65615 .56956 .63471 .54996 Metetra
.703 .82 .937 r
.63471 .54996 .65615 .56956 .7001 .54782 .67942 .53051 Metetra
.708 .848 .95 r
.67942 .53051 .7001 .54782 .74461 .52695 .72466 .51006 Metetra
.7 .855 .957 r
.72466 .51006 .74461 .52695 .78984 .50809 .77053 .49002 Metetra
.686 .844 .959 r
.77053 .49002 .78984 .50809 .83593 .4915 .81714 .47118 Metetra
.672 .82 .955 r
.81714 .47118 .83593 .4915 .88297 .47686 .86461 .4538 Metetra
.546 .631 .887 r
.25028 .46508 .27416 .49663 .31039 .49679 .28674 .46337 Metetra
.305 .499 .883 r
.28674 .46337 .31039 .49679 .34651 .51372 .32306 .47663 Metetra
.215 .421 .848 r
.32306 .47663 .34651 .51372 .38362 .53717 .36024 .49647 Metetra
.263 .428 .839 r
.36024 .49647 .38362 .53717 .42224 .55916 .39884 .51639 Metetra
.357 .474 .842 r
.39884 .51639 .42224 .55916 .46249 .57444 .43902 .53191 Metetra
.448 .531 .849 r
.43902 .53191 .46249 .57444 .50416 .58053 .48069 .54057 Metetra
.524 .588 .861 r
.48069 .54057 .50416 .58053 .54694 .57733 .52365 .54162 Metetra
.586 .647 .877 r
.52365 .54162 .54694 .57733 .59052 .56637 .56761 .53563 Metetra
.633 .704 .897 r
.56761 .53563 .59052 .56637 .63471 .54996 .61238 .52393 Metetra
.666 .757 .918 r
.61238 .52393 .63471 .54996 .67942 .53051 .6578 .50821 Metetra
.685 .8 .936 r
.6578 .50821 .67942 .53051 .72466 .51006 .70383 .49006 Metetra
.69 .828 .949 r
.70383 .49006 .72466 .51006 .77053 .49002 .75047 .47083 Metetra
.687 .839 .956 r
.75047 .47083 .77053 .49002 .81714 .47118 .7978 .45149 Metetra
.679 .837 .959 r
.7978 .45149 .81714 .47118 .86461 .4538 .84589 .43264 Metetra
.564 .644 .888 r
.22579 .43356 .25028 .46508 .28674 .46337 .26253 .42994 Metetra
.368 .539 .892 r
.26253 .42994 .28674 .46337 .32306 .47663 .29911 .43938 Metetra
.284 .466 .863 r
.29911 .43938 .32306 .47663 .36024 .49647 .33645 .45509 Metetra
.307 .455 .845 r
.33645 .45509 .36024 .49647 .39884 .51639 .37508 .4719 Metetra
.372 .478 .838 r
.37508 .4719 .39884 .51639 .43902 .53191 .41521 .48615 Metetra
.441 .513 .837 r
.41521 .48615 .43902 .53191 .48069 .54057 .45684 .49564 Metetra
.501 .553 .842 r
.45684 .49564 .48069 .54057 .52365 .54162 .49985 .49935 Metetra
.551 .596 .852 r
.49985 .49935 .52365 .54162 .56761 .53563 .54403 .49724 Metetra
.593 .641 .868 r
.54403 .49724 .56761 .53563 .61238 .52393 .5892 .48992 Metetra
.626 .687 .887 r
.5892 .48992 .61238 .52393 .6578 .50821 .63521 .47837 Metetra
.651 .731 .908 r
.63521 .47837 .6578 .50821 .70383 .49006 .68196 .46369 Metetra
.667 .769 .926 r
.68196 .46369 .70383 .49006 .75047 .47083 .7294 .4469 Metetra
.674 .797 .94 r
.7294 .4469 .75047 .47083 .7978 .45149 .77755 .42888 Metetra
.675 .814 .95 r
.77755 .42888 .7978 .45149 .84589 .43264 .82644 .41032 Metetra
.579 .668 .9 r
.20049 .40374 .22579 .43356 .26253 .42994 .23756 .39821 Metetra
.417 .584 .909 r
.23756 .39821 .26253 .42994 .29911 .43938 .27449 .40372 Metetra
.341 .516 .884 r
.27449 .40372 .29911 .43938 .33645 .45509 .31209 .41488 Metetra
.35 .492 .861 r
.31209 .41488 .33645 .45509 .37508 .4719 .35085 .42768 Metetra
.395 .496 .844 r
.35085 .42768 .37508 .4719 .41521 .48615 .39101 .43926 Metetra
.445 .514 .835 r
.39101 .43926 .41521 .48615 .45684 .49564 .43262 .44777 Metetra
.492 .538 .832 r
.43262 .44777 .45684 .49564 .49985 .49935 .47563 .45222 Metetra
.531 .565 .835 r
.47563 .45222 .49985 .49935 .54403 .49724 .5199 .45225 Metetra
.565 .596 .844 r
.5199 .45225 .54403 .49724 .5892 .48992 .56531 .44803 Metetra
.593 .63 .857 r
.56531 .44803 .5892 .48992 .63521 .47837 .61172 .44002 Metetra
.617 .664 .873 r
.61172 .44002 .63521 .47837 .68196 .46369 .65903 .42884 Metetra
.636 .699 .891 r
.65903 .42884 .68196 .46369 .7294 .4469 .70717 .41516 Metetra
.649 .73 .908 r
.70717 .41516 .7294 .4469 .77755 .42888 .75611 .39962 Metetra
.658 .757 .923 r
.75611 .39962 .77755 .42888 .82644 .41032 .80585 .38278 Metetra
.59 .719 .933 r
.17391 .37886 .20049 .40374 .23756 .39821 .2114 .37143 Metetra
.448 .649 .944 r
.2114 .37143 .23756 .39821 .27449 .40372 .24881 .37293 Metetra
.382 .584 .922 r
.24881 .37293 .27449 .40372 .31209 .41488 .28684 .37923 Metetra
.385 .549 .894 r
.28684 .37923 .31209 .41488 .35085 .42768 .3259 .3873 Metetra
.419 .538 .87 r
.3259 .3873 .35085 .42768 .39101 .43926 .36624 .39498 Metetra
.458 .539 .852 r
.36624 .39498 .39101 .43926 .43262 .44777 .40794 .40085 Metetra
.494 .548 .84 r
.40794 .40085 .43262 .44777 .47563 .45222 .45098 .40405 Metetra
.525 .561 .835 r
.45098 .40405 .47563 .45222 .5199 .45225 .49532 .40416 Metetra
.551 .579 .835 r
.49532 .40416 .5199 .45225 .56531 .44803 .54086 .40111 Metetra
.574 .599 .84 r
.54086 .40111 .56531 .44803 .61172 .44002 .58752 .39505 Metetra
.594 .621 .849 r
.58752 .39505 .61172 .44002 .65903 .42884 .63521 .38627 Metetra
.61 .645 .86 r
.63521 .38627 .65903 .42884 .70717 .41516 .68387 .37514 Metetra
.624 .67 .874 r
.68387 .37514 .70717 .41516 .75611 .39962 .73345 .36205 Metetra
.635 .694 .887 r
.73345 .36205 .75611 .39962 .80585 .38278 .78394 .34736 Metetra
.573 .82 .991 r
.14517 .36437 .17391 .37886 .2114 .37143 .18323 .35507 Metetra
.433 .752 .994 r
.18323 .35507 .2114 .37143 .24881 .37293 .22133 .35256 Metetra
.381 .69 .98 r
.22133 .35256 .24881 .37293 .28684 .37923 .26002 .35378 Metetra
.395 .65 .96 r
.26002 .35378 .28684 .37923 .3259 .3873 .29965 .35658 Metetra
.433 .624 .933 r
.29965 .35658 .3259 .3873 .36624 .39498 .34042 .3594 Metetra
.471 .608 .905 r
.34042 .3594 .36624 .39498 .40794 .40085 .38242 .36121 Metetra
.504 .599 .882 r
.38242 .36121 .40794 .40085 .45098 .40405 .42569 .36135 Metetra
.53 .598 .866 r
.42569 .36135 .45098 .40405 .49532 .40416 .4702 .35948 Metetra
.552 .601 .856 r
.4702 .35948 .49532 .40416 .54086 .40111 .51591 .35544 Metetra
.569 .608 .852 r
.51591 .35544 .54086 .40111 .58752 .39505 .56278 .34923 Metetra
.585 .618 .851 r
.56278 .34923 .58752 .39505 .63521 .38627 .61076 .34097 Metetra
.598 .63 .854 r
.61076 .34097 .63521 .38627 .68387 .37514 .65979 .33082 Metetra
.609 .644 .86 r
.65979 .33082 .68387 .37514 .73345 .36205 .70986 .31898 Metetra
.619 .659 .868 r
.70986 .31898 .73345 .36205 .78394 .34736 .76093 .30566 Metetra
.338 .819 .841 r
.11284 .36792 .14517 .36437 .18323 .35507 .15174 .35679 Metetra
.205 .733 .802 r
.15174 .35679 .18323 .35507 .22133 .35256 .19084 .35024 Metetra
.202 .725 .853 r
.19084 .35024 .22133 .35256 .26002 .35378 .23054 .34624 Metetra
.274 .75 .935 r
.23054 .34624 .26002 .35378 .29965 .35658 .27111 .34335 Metetra
.369 .762 .987 r
.27111 .34335 .29965 .35658 .34042 .3594 .31269 .34056 Metetra
.446 .751 .993 r
.31269 .34056 .34042 .3594 .38242 .36121 .35538 .3372 Metetra
.5 .729 .975 r
.35538 .3372 .38242 .36121 .42569 .36135 .3992 .33284 Metetra
.536 .708 .951 r
.3992 .33284 .42569 .36135 .4702 .35948 .44418 .32721 Metetra
.56 .692 .929 r
.44418 .32721 .4702 .35948 .51591 .35544 .4903 .3202 Metetra
.577 .682 .912 r
.4903 .3202 .51591 .35544 .56278 .34923 .53754 .31175 Metetra
.591 .676 .9 r
.53754 .31175 .56278 .34923 .61076 .34097 .58589 .30189 Metetra
.601 .674 .892 r
.58589 .30189 .61076 .34097 .65979 .33082 .63532 .2907 Metetra
.609 .676 .888 r
.63532 .2907 .65979 .33082 .70986 .31898 .68584 .27825 Metetra
.617 .679 .886 r
.68584 .27825 .70986 .31898 .76093 .30566 .73742 .26464 Metetra
.085 0 0 r
.07528 .39598 .11284 .36792 .15174 .35679 .11538 .38303 Metetra
.124 0 0 r
.11538 .38303 .15174 .35679 .19084 .35024 .1559 .37235 Metetra
.106 0 0 r
.1559 .37235 .19084 .35024 .23054 .34624 .19708 .36288 Metetra
.042 0 0 r
.19708 .36288 .23054 .34624 .27111 .34335 .23907 .3539 Metetra
.23907 .3539 .27111 .34335 .31269 .34056 .28197 .34487 Metetra
.199 .727 .753 r
.28197 .34487 .31269 .34056 .35538 .3372 .32584 .33547 Metetra
.335 .813 .89 r
.32584 .33547 .35538 .3372 .3992 .33284 .37071 .32546 Metetra
.443 .85 .968 r
.37071 .32546 .3992 .33284 .44418 .32721 .4166 .31471 Metetra
.516 .852 .996 r
.4166 .31471 .44418 .32721 .4903 .3202 .46352 .30315 Metetra
.561 .836 .997 r
.46352 .30315 .4903 .3202 .53754 .31175 .51149 .29075 Metetra
.588 .816 .986 r
.51149 .29075 .53754 .31175 .58589 .30189 .5605 .2775 Metetra
.605 .798 .973 r
.5605 .2775 .58589 .30189 .63532 .2907 .61057 .26341 Metetra
.617 .782 .961 r
.61057 .26341 .63532 .2907 .68584 .27825 .66169 .24853 Metetra
.624 .77 .95 r
.66169 .24853 .68584 .27825 .73742 .26464 .71389 .23287 Metetra
.22 0 0 r
.03198 .44572 .07528 .39598 .11538 .38303 .07361 .43088 Metetra
.21 0 0 r
.07361 .43088 .11538 .38303 .1559 .37235 .11599 .41579 Metetra
.181 0 0 r
.11599 .41579 .1559 .37235 .19708 .36288 .15912 .40042 Metetra
.135 0 0 r
.15912 .40042 .19708 .36288 .23907 .3539 .20304 .38478 Metetra
.068 0 0 r
.20304 .38478 .23907 .3539 .28197 .34487 .24775 .36885 Metetra
.24775 .36885 .28197 .34487 .32584 .33547 .29329 .35263 Metetra
.29329 .35263 .32584 .33547 .37071 .32546 .33967 .33611 Metetra
.246 .745 .676 r
.33967 .33611 .37071 .32546 .4166 .31471 .38692 .31928 Metetra
.359 .831 .806 r
.38692 .31928 .4166 .31471 .46352 .30315 .43507 .30212 Metetra
.454 .882 .899 r
.43507 .30212 .46352 .30315 .51149 .29075 .48413 .28465 Metetra
.523 .902 .954 r
.48413 .28465 .51149 .29075 .5605 .2775 .53414 .26683 Metetra
.569 .901 .981 r
.53414 .26683 .5605 .2775 .61057 .26341 .58513 .24867 Metetra
.599 .888 .99 r
.58513 .24867 .61057 .26341 .66169 .24853 .63712 .23015 Metetra
.617 .872 .99 r
.63712 .23015 .66169 .24853 .71389 .23287 .69014 .21126 Metetra
P
p
.002 w
.67932 .02494 m
.94594 .43277 L
s
.94594 .43277 m
.97506 .64585 L
s
.97506 .64585 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.06024 .26735 m
.02494 .49015 L
s
.02494 .49015 m
.69286 .25814 L
s
.69286 .25814 m
.67932 .02494 L
s
.67932 .02494 m
.06024 .26735 L
s
P
p
p
.002 w
.06024 .26735 m
.67932 .02494 L
s
P
p
.002 w
.06024 .26735 m
.0648 .2716 L
s
P
[(0)] .05113 .25884 1 .93395 Mshowa
p
.002 w
.24126 .19647 m
.24553 .20101 L
s
P
[(1)] .23273 .18737 .938 1 Mshowa
p
.002 w
.43658 .11999 m
.44049 .12484 L
s
P
[(2)] .42876 .11027 .80527 1 Mshowa
p
.002 w
.64798 .03721 m
.65146 .04238 L
s
P
[(3)] .64102 .02686 .67254 1 Mshowa
p
.001 w
.09538 .25359 m
.09808 .25618 L
s
P
p
.001 w
.13104 .23963 m
.1337 .24225 L
s
P
p
.001 w
.16723 .22546 m
.16986 .22811 L
s
P
p
.001 w
.20396 .21107 m
.20656 .21376 L
s
P
p
.001 w
.27913 .18164 m
.28165 .1844 L
s
P
p
.001 w
.31758 .16658 m
.32006 .16938 L
s
P
p
.001 w
.35663 .15129 m
.35907 .15413 L
s
P
p
.001 w
.39629 .13576 m
.39869 .13864 L
s
P
p
.001 w
.47752 .10396 m
.47981 .10691 L
s
P
p
.001 w
.5191 .08767 m
.52135 .09066 L
s
P
p
.001 w
.56137 .07112 m
.56356 .07415 L
s
P
p
.001 w
.60432 .05431 m
.60646 .05737 L
s
P
P
% End of Graphics
MathPictureEnd
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
No Input Form was saved for this expression.





























;[o]
-SurfaceGraphics-
:[font = text; inactive; nohscroll; ]
The graphics is included into the \TeX\ document by using the \textsf{epsfig}-macros of \LaTeXe. This offers a portable, and DVI-driver independent treatment of the document produced by \mnbtoltx. One needs still a PostScript printer or interpreter to print the obtained DVI-files.
:[font = section; inactive; nohscroll; ]
Installation
:[font = subsection; inactive; nohscroll; ]
Files
:[font = text; inactive; nohscroll; ]
\begin{tabular}{| l | l |}
\hline
\textsf{mnb2ltx.w}  & the CWeb source file of the program \\
\textsf{mnb2ltx.c}  & the C-source produced by ctangle    \\
\textsf{cmdln.h}    & C-header for command line processing \\
\textsf{cmdln.c}    & C-source for command line switches   \\
\textsf{Makefile}  & make file for Unix (on Sun with Solaris 2.3) \\
\hline
\textsf{mathps.pro} & PostScript prolog file \\
\hline
\textsf{mathnb.sty} & style file for \LaTeXe used in the output
                      of \mnbtoltx. \\
\hline
\textsf{manual.ma}           & Manual as Mathematica 2.2 notebook  \\
\textsf{manual.tex}          & \TeX-file of the manual             \\
\textsf{manual.dvi}          & DVI-file                            \\
\textsf{manual.ps}           & PostScript file of the manual       \\
\textsf{man0.ps, man1.ps}  & pictures extracted from manual.ma \\
\hline
\textsf{./pc/mnb2ltx.exe} & compiled executable for  OS/2 \\
\textsf{./pc/mnb2ltxw.exe} & compiled executable for Windows 95  \\
\hline
\end{tabular}  
:[font = subsection; inactive; nohscroll; ]
Compiling 
:[font = subsubsection; inactive; nohscroll; ]
Unix
:[font = text; inactive; nohscroll; ]
The source code of the converter is written in \texttt{CWEB} 3.4c\footnote{This powerfull system for literate programming by D. E. Knuth and S. Levi can be found on the CTAN cites \texttt{/tex/web/cweb}.}. \texttt{CWEB} is needed only when the source code is changed or modifyed. Don't change the file \textsf{mnb2ltx.c} directly.
Use simply the \textsf{Makefile} after updating the path for MathLink and the additional librarys.

If no \texttt{CWEB} is available the commands 
\begin{verbatim}
cc -c cmdln.c
cc -c -DUSE_MATHLINK -Imathematica/Includes mnb2ltx.c 
cc -o mnb2ltx mnb2ltx.o cmdln.o -Lmathematica/Bin -lmathlink
\end{verbatim}

will do the job. You have to set the correct include path and library path for your Mathematica instalation. With the compiler option \verb|-UUSE_MATHLINK| the MathLink header and library is not needed. The Windows 95 executable is compiled with Borland C 4.5, the OS/2 exectutable with Borland C 2.0. For OS/2 Gnu C as well as Watcom C 10.5 can be used. The Borland C executable is included because it is the fastest.

If \mnbtoltx\ is compiled with out MathLink support
:[font = input; startGroup; nowordwrap; ]
 Series[BesselJ[0,x],{x,0,8}] // TeXForm
:[font = output; inactive; formatted; output; endGroup; nowordwrap; ]
1 - {{{x^2}}\over 4} + {{{x^4}}\over {64}} - {{{x^6}}\over {2304}} + 
  {{{x^8}}\over {147456}} + {{{\rm O}(x)}^{10}}

























;[o]
1 - {{{x^2}}\over 4} + {{{x^4}}\over {64}} - {{{x^6}}\over {2304}} + 
  {{{x^8}}\over {147456}} + {{{\rm O}(x)}^{10}}
:[font = text; inactive; nohscroll; ]
and all other forms of \texttt{TeXForm} will still work but the automatic conversation of all \texttt{Out[]}-cells enforced by the \verb|+mout| switch of the program will \emph{not} work. All MathLink related comand line switches are meaningless.
:[font = subsubsection; inactive; nohscroll; ]
OS/2, Windows 95
:[font = text; inactive; nohscroll; ]
You can use the precompiled versions included or recompile the source as described for Unix. The Windows Version is not well tested, it works with Windows 3.1 and Win32s and with Windows 95.
 
:[font = subsection; inactive; nohscroll; ]
Install the files
:[font = text; inactive; nohscroll; ]
Place the executable \mnbtoltx\ into the search \texttt{PATH} of your operating system, put \textsf{mathnb.sty} in a directory where \TeX\ searches for its input files and \textsf{mathps.pro} in the directory where the executable  \verb|mnb2ltx[w][.exe]| is located.
:[font = section; inactive; nohscroll; ]
Commandline switches
:[font = text; inactive; nohscroll; ]
Every argument passed to \mnbtoltx\ must be preceeded by a switch starting with a minus or plus sign. The switch indicates the meaning of the following argument. 
:[font = subsection; inactive; nohscroll; ]
Input and Output Files
:[font = text; inactive; nohscroll; ]
As a minimum of arguments the program needs to know the name of the notebook file that should be converted. The simplest usage is

\begin{verbatim}
~/mnb2ltx> mnb2ltx -fin sample
\end{verbatim}

if no extension is given then \verb|.ma| is appended to the name following the \verb|-fin| switch. The output file will then \textsf{sample.tex}. With the switch \verb|-fout| you can give an other output file (without the extension \verb|.tex|).
\mnbtoltx\ is written so that the output file can directly be translated with \LaTeXe{} to a DVI-file. 
:[font = subsection; inactive; nohscroll; ]
PostScript
:[font = text; inactive; nohscroll; ]
The PostScript related switches are:

\begin{table}[h]
\begin{tabular}{| l | l | l |}
\hline
\textit{switch}              & \textit{default value}  &  \textit{meaning}  \\
\hline
\texttt{-psprfx} \textit{string}  & \texttt{"pic"} & prefix for the exported PostScript files \\
\texttt{-paspect/+paspect} & True    & preserve the aspect ratio of the picture \\
\texttt{-pwidth} \textit{float} & 322 bp        & width of the PostScript pictures \\
\texttt{-pheight} \it{float} & 200 bp      & height of the PostScript pictures \\
\texttt{-pspro} \textit{filename}  &\textsf{mathps.pro} & Mathematica 2.2 graphics prolog file \\
\hline
\end{tabular}
\end{table}

All pictures found in the notebook will be written into separate files, the first characters of this file names are determined by the \texttt{-psprfx} argument.
The files are labeled as \textsf{pic0.ps}, \textsf{pic1.ps} and so on. The user has to make sure that the file names are compatible with the operating system. If for example, there are 100 figures in the notebook and the prefix is choosen to \textsf{verrylong} one may have trouble on MS-DOS (or OS/2 with FAT file system).

The width and the height of the pictures is only of interest if the exported pictures shall be printed without using \LaTeXe\ and with respect of the font size in the graphics. If the aspect ratio of the picture is preserved the height is calculated from the width and the aspect ratio. With the help of the \TeX-macros in the \textsf{graphics}-packages it is easy to change the scaling of the pictures as well as the aspect ratio in the \TeX-file. At the beginning of the ouput file one will find the line

\begin{verbatim}
\setlength{\MathPicX}{ width bp}
\end{verbatim}

\noindent changing the width here will rescale all pictures (including the size of labels!).
If the prolog file is not in the current directory the \texttt{-pspro} argument must be given.
:[font = subsection; inactive; nohscroll; ]
Transformation of Text cells in Notebooks
:[font = text; inactive; nohscroll; ]
The \LaTeXe\ style file \textsf{mathnb.sty} defines \TeX\ environments for the special cells of a notebook and the small text cells. Since Mathematica uses for its command syntax nearly all special characters some conversion must be done to prevent errors of  \TeX\ due to the use of Mathematica constructs in text cells. A simple copy of things like  \verb|$MachineEpsilon| or \verb|a^b| will cause a lot of trouble when the file is translated with \TeX. There are three kinds of conversions:

\begin{description}
\item[replace]  all reserved \TeX characters like \verb|%|, \verb|#|, \verb|$| are replaced by its equivalents for \TeX's text mode
\item[alltt] only the characters reserved by the \textsf{alltt} environment, \verb|{|,
\verb|}| and \verb|\| will be replaced.
\item[copy]  the contens of the cell is copyed without any conversation
\end{description}

The last option is useful if one prepare a notebook for usage with \mnbtoltx. Then one can use in text cells the \TeX\ commands and has so full controll over the typesetting of the notebook, including correct formulas. The \textsf{manual.ma} file  must be translated with this option. The replacement option for text \verb|-ct|  applies also to titles, sections and small text cells.

When a notebook is converted that was not designed for use with \mnbtoltx\ the replace mode is relatively safe. Usual such a notebook need some fine tuning before it gives the optimal output.

The alltt conversion is for cases where the notebook authors have used special cells to display program code  than one may use either the copy option or the alltt option and redefine the corresponding \LaTeX-environment to verbatim or alltt.
 The switches for the cell types are

\begin{table}[ht]
\begin{tabular} {| l  | l | l |}
\hline
\textit{switch}              & \textit{default value}  &  \textit{meaning}  \\
\hline
\texttt{-ct}   \textit{string}  & copy  &  replacement in text related cells like text \\
\texttt{-cs1} \textit{string} &  replace            & replacement in special 1 cells \\
$\hfil \vdots$   \hfil $\vdots$  $\vdots$           &      &  \hfil $\vdots$  \\
\texttt{-cs5} \textit{string} & replace & replacement in special 5 cells \\
\hline
\end{tabular}
\end{table}
:[font = subsection; inactive; nohscroll; ]
Transforming all output to \TeX, MathLink
:[font = text; inactive; nohscroll; ]
One special feature of \mnbtoltx\ is that it can call Mathematica to transform all \texttt{Out[\_]} cells into its \texttt{TeXForm}. If one is running the program with
the \verb|+mout| switch than it trys to open a MathLink connection to Mathematica and convert the \texttt{InputForm} of the output cells into its \texttt{TeXForm}. This option has the advantage that one does not  need to type \verb| % //TeXForm| in the input lines. If the results are rather long expressions
one has to break the expressions over lines by hand (!) this may be  hard work because the \TeX\ generated by \texttt{TeXForm} is not easy to read due to the extensive usage of brakets.  The \mnbtoltx\ program will never try to break the expressions over lines. Expressions that do not fit in a single line of the \TeX\ document will produce overfull box messages. The \TeX-output of Mathematica is enclosed in the 

\begin{verbatim}
\MathOutLabel
\begin{displaymath}
...<some TeXForm>
\end{displaymath}
\end{verbatim}

If one breaks the formula over lines one has to replace this environment by  something like the \verb|eqnarray| environment. If a notebook contains a lot of formulas the automatic conversion makes it much easyer to read.

The option \texttt{+mout} tries \emph{not} to evaluate the input lines of the notebook. Information about the \verb|Format[_,TeXForm]| like

\begin{verbatim}
Format[a0,TeXForm]:="a_0"
\end{verbatim}

in the notebook or in additional Mathematica input files will be lost if the notebook is converted by this option. For such cases the usage of \texttt{TeXForm} in selected input lines is recommended.

Additionaly \mnbtoltx\ has two command line arguments that are passed to MathLink, for a detailed reference see the MathLink manual.

\begin{table}[ht]
\begin{tabular} {| l  | l | l |}
\hline
\textit{switch}              & \textit{default value}  &  \textit{meaning}  \\
\hline
\texttt{-mout, +mout}   & off  &  with \texttt{+mout} the output is converted to \TeX \\
\texttt{-linkname} \textit{string} &  \texttt{``math -mathlink''}   & see the MathLink manual  \\
\texttt{-linkmode} \textit{string} & \texttt{launch} & see the MathLink manual \\
\hline
\end{tabular}
\end{table}
:[font = section; inactive; nohscroll; ]
The Style file \textsf{mathnb.sty}
:[font = text; inactive; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 12; ]
The produced output file will load besides other packages the style \textsf{mathnb}. This style determines the formatting of the different cells. The style file has three options:
\begin{description}
 \item[nolabels] Prevent the output of the numbered \textit{In[\_]:=} and \textit{Out[\_]=} labels at the beginning of Mathematica input and output cells. 
\item[finput] Will draw a frame arround each input cell. Input cells containing initialisation code will be framed and have a light gray background.
\item[psfonts] Will use the \textsf{time.sty} and \textsf{mathptm.sty} to replace the Computer Modern fonts with PostScript fonts, it will also produce input text in Courier-Bold.
\end{description}

For notebook cells that are enclosed by the alltt environment (output, print, message, information) the line width is determined by the notebook. If smaller lines in these cells are desired one has to set the \verb|PageWidth| option of \verb|$Output| properly. 
:[font = input; nowordwrap; ]
Options[$Output]
:[font = output; inactive; formatted; output; nowordwrap; ]
{FormatType -> OutputForm, PageWidth -> 45, 
  PageHeight -> 22, 
  TotalWidth -> DirectedInfinity[1], 
  TotalHeight -> DirectedInfinity[1], 
  StringConversion :> $StringConversion}










;[o]
{FormatType -> OutputForm, PageWidth -> 45, 
 
 PageHeight -> 22, TotalWidth -> Infinity, 
 
 TotalHeight -> Infinity, 
 
 StringConversion :> $StringConversion}
:[font = text; inactive; nohscroll; ]
If the line width of  \texttt{mathnb.sty} is modifyed one has to evaluate the notebook with a smaller  \verb|PageWidth|.
:[font = input; nowordwrap; ]
SetOptions[$Output,PageWidth->45];
:[font = text; inactive; nohscroll; ]


:[font = text; inactive; nohscroll; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; plain; fontName = "Times New Roman"; fontSize = 12; ]
The cell types of the notebook will be converted into \TeX\ commands, and 
\LaTeX\ environments. The defined commands are:

\begin{table}
\begin{minipage}{0.9\linewidth}
\begin{tabular}{| l | l |}
\hline
Mathematica cell type  &  \mnbtoltx\ equivalent \\
\hline\hline
Title                             & \protect\verb|\MathTitle{...}| \\
Subtitle                         & \protect\verb|\MathSubTitle{...}| \\
Subsubtitle                   & \protect\verb|\MathSubSubTitle{...}| \\
\hline
Section                     & \protect\verb|\section{...}|         \\
Subsection                & \protect\verb|\subsection{...}|   \\
Subsubsection          & \protect\verb|\subsubsection{...}| \\
\hline
\multicolumn{2}{|l|}{Environments} \\
\hline
Special 1   &  \texttt{MathSpecial1}  \\
 \vdots       &  \vdots                  \\
Special 2   &  \texttt{MathSpecial2}  \\
Input   &  \texttt{MathIn}  \\
Input with Initialisation & \texttt{MathInInit} \\
Output & \texttt{MathOut}\protect\footnote{if it is no \texttt{TeXForm}} \\
Text    &  no environment \\
Small text &  \texttt{MathSmall} \\
Print         & \texttt{MathPrint} \\
Information & \texttt{MathInfo} \\
Message     & \texttt{MathMessage} \\
PostScript  &  \texttt{MathGraph} \\
\hline
\end{tabular}
\end{minipage}
\end{table}
:[font = section; inactive; nohscroll; ]
Last Words
:[font = text; inactive; nohscroll; ]
The structure of Mathematica 2.2 Notebooks is not well documented and all information about this structure is based on the notebooks I have seen and trail and error.
If any one discover a bug, let me know it or better send me a \texttt{CWEB} change file.
If any one like to port the program to a Mac, please send me the change file.
Suggestions, bug reports and extensions for the program are welcome.
:[font = section; inactive; nohscroll; ]
Copyright
:[font = text; inactive; nohscroll; ]
The Copyright of MathLink belongs to Wolfram Research Inc.
The source code, the program and the style file  may be freely distributed. It is
not allowed to sell the program or parts of it with out my special permission.
Changes of the source code are only allowed by using the change files of
\texttt{CWEB} or if the file has a different name. Never change my original \texttt{CWEB} source!
^*)