#define VERSION "Version 1.0beta"
#define BANNER "Mathematica 2.2 Notebook -> LaTeX2e\n" \
" (c) 1995 J.-P. Kuska "VERSION" from "__DATE__"\n" \
" MathLink copyright 1995 Wolfram Research, Inc.\n"
#define True (1) 
#define False (0) 
#define PROGNAME "mnb2ltx"
#define CRITICAL (1) 
#define NONCRITICAL (0)  \

#define CellTitle 1
#define CellSubTitle 2
#define CellSubSubTitle 3
#define CellSection 4
#define CellSubSection 5
#define CellSubSubSection 6
#define CellText 7
#define CellSmallText 8
#define CellInput 9
#define CellOutput 10
#define CellMessage 11
#define CellPrint 12
#define CellGraphics 13
#define CellPostScript 14
#define CellInformation 15
#define CellSpecial1 16
#define CellSpecial2 17
#define CellSpecial3 18
#define CellSpecial4 19
#define CellSpecial5 20
#define CellHelp 21
#define CellMathMath 22
#define CellMathInitial 23
#define COPY "copy"
#define ALLTT "alltt"
#define REPLACE "replace"
#define UNUSED "unused"
#define MaxCells 21
#define MaxNameLength 256
#define NBExtension ".ma"
#define BeginCellDescriptor "\n:["
#define EndCellDescriptor "]"
#define EndNotebook "^*)"
#define MathCommentClose "*)"
#define MathCommentOpen "(*" \

#define MaxMathArgc 8
#define TeXFormBufferSize 16384 \

#define WaitLoop 100000L
#define BeginAspectRatio "AspectRatio"
#define MathPSEnd "MathPictureEnd"
#define Special_alltt "{}\\"
#define Special_TeX "{}\\#&^_$<>|"
#define BeginOut2D ";[o]\n"
#define BeginFontSet ";[s]\n" \

#define NoInputForm "No Input Form" \

/*1:*/
#line 25 "MNB2LTX.W"

#if !defined(__WIN32__) & !defined(__WATCOMC__) & defined(WINDOWS_MATHLINK)
#  define CALLOC farcalloc
#  define MALLOC farmalloc
#  define FREE   farfree
#  define MEMSET _fmemset
#  define STRSTR _fstrstr
#  define MEMMOVE _fmemmove
#elif defined(WINDOWS_MATHLINK) & defined(__WATCOMC__)
#  define CALLOC _fcalloc
#  define MALLOC _fmalloc
#  define FREE   _ffree
#  define MEMSET _fmemset
#  define STRSTR _fstrstr
#  define MEMMOVE _fmemmove
#else
#  define CALLOC calloc
#  define MALLOC malloc
#  define FREE free
#  define MEMSET memset
#  define STRSTR strstr
#  define MEMMOVE memmove
#endif
/*58:*/
#line 1283 "MNB2LTX.W"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>
#include <stdarg.h>
#include <fcntl.h>
#ifdef __GNUC__
#include <sys/types.h>
#endif
#include <sys/stat.h>
#ifdef USE_MATHLINK
#define P(s) s
#include "mathlink.h"
#endif
#pragma hdrstop
#include "cmdln.h"
#ifdef __WATCOMC__
#include <malloc.h>
#endif
/*:58*/
#line 48 "MNB2LTX.W"

/*8:*/
#line 236 "MNB2LTX.W"

typedef struct NotebookCell{int what;
char*NBKey;
char TranslationType[64];
char*TeXProlog;
char*TeXEpilog;
}NotebookCell;

/*:8*/
#line 49 "MNB2LTX.W"

/*9:*/
#line 250 "MNB2LTX.W"

NotebookCell CellTypes[MaxCells+2]= 
{{CellTitle,
"title",
REPLACE,
"\\MathTitle{",
"}\n"},
{CellSubTitle,
"subtitle",
REPLACE,
"\\MathSubTitle{",
"}\n"},
{CellSubSubTitle,
"subsubtitle",
REPLACE,
"\\MathSubSubTitle{",
"}\n"},
{CellSection,
"section",
REPLACE,
"\\section{",
"}\n\n"},
{CellSubSection,
"subsection",
REPLACE,
"\\subsection{",
"}\n\n"},
{CellSubSubSection,
"subsubsection",
REPLACE,
"\\subsubsection{",
"}\n\n"},
{CellText,
"text",
COPY,
"",
"\n\\par\n"},
{CellSmallText,
"smalltext",
COPY,
"\\begin{MathSmall}\n",
"\n\\end{MathSmall}\n"},
{CellInput,
"input",
UNUSED,
"\\begin{MathIn}\n",
"\n\\end{MathIn}\n"},
{CellOutput,
"output",
UNUSED,
"\\begin{MathOut}\n",
"\n\\end{MathOut}\n"},
{CellMessage,
"message",
UNUSED,
"\\begin{MathMessage}\n",
"\n\\end{MathMessage}\n"},
{CellPrint,
"print",
UNUSED,
"\\begin{MathPrint}\n",
"\n\\end{MathPrint}\n"},
{CellGraphics,
"graphics",
UNUSED,
"\\begin{MathGraph}\n",
"\\end{MathGraph}\n"},
{CellPostScript,
"postscript",
UNUSED,
"\\begin{MathGraph}\n",
"\\end{MathGraph}\n"},
{CellInformation,
"info",
UNUSED,
"\\begin{MathInfo}\n",
"\n\\end{MathInfo}\n"},
{CellSpecial1,
"special1",
REPLACE,
"\\begin{MathSpecial1}\n",
"\n\\end{MathSpecial1}\n"},
{CellSpecial2,
"special2",
REPLACE,
"\\begin{MathSpecial2}\n",
"\n\\end{MathSpecial2}\n"},
{CellSpecial3,
"special3",
REPLACE,
"\\begin{MathSpecial3}\n",
"\n\\end{MathSpecial3}\n"},
{CellSpecial4,
"special4",
REPLACE,
"\\begin{MathSpecial4}\n",
"\n\\end{MathSpecial4}\n"},
{CellSpecial5,
"special5",
REPLACE,
"\\begin{MathSpecial5}\n",
"\n\\end{MathSpecial5}\n"},
{CellHelp,
"help",
REPLACE,
"",
"\n\\par\n"},
{CellMathMath,
"",
UNUSED,
"\\MathOutLabel\n\\begin{displaymath}\n",
"\n\\end{displaymath}\n"},
{CellMathInitial,
"",
UNUSED,
"\\begin{MathInInit}\n",
"\\end{MathInInit}\n"}
};

/*:9*//*11:*/
#line 381 "MNB2LTX.W"

char NotebookName[MaxNameLength]= "";
FILE*NBFile= NULL;
char TeXFileName[MaxNameLength]= "";
FILE*TeXFile;

/*:11*//*12:*/
#line 388 "MNB2LTX.W"

char*InputBuffer,*EndBuffer;
long int BufferSize= 16384;
long int BufferCount= 0;
long int BufferPos= 0;

/*:12*//*24:*/
#line 522 "MNB2LTX.W"

int CallMathematica= False;
int MLDone= 0;
char LinkMode[MaxNameLength]= "launch";

#if defined( WINDOWS_MATHLINK)
char LinkName[MaxNameLength]= "c:\\wnmath22\\math.exe -mathlink";
char LinkProtocol[MaxNameLength]= "tcp";

long int MathArgc= 6L;

char*MathArgv[MaxMathArgc+1]= 
{"-linkname",LinkName,
"-linkmode",LinkMode,
"-linkprotocol",LinkProtocol,
NULL};
#elif defined(OS2_MATHLINK)
char LinkName[MaxNameLength]= "math.cmd -mathlink";
char LinkProtocol[MaxNameLength]= "";

long int MathArgc= 4L;

char*MathArgv[MaxMathArgc+1]= 
{"-linkname",LinkName,
"-linkmode",LinkMode,
NULL};
#else
char LinkName[MaxNameLength]= "math -mathlink";
char LinkProtocol[MaxNameLength]= "";

long int MathArgc= 4L;
char*MathArgv[MaxMathArgc+1]= 
{"-linkname",LinkName,
"-linkmode",LinkMode,
NULL};
#endif

#ifdef USE_MATHLINK
MLINK MLinkPtr;
MLEnvironment MLEnv;
char MathTeXString[TeXFormBufferSize];
#endif

/*:24*//*29:*/
#line 691 "MNB2LTX.W"

char PSPrologFile[MaxNameLength]= "mathps.pro";

char PSFilePrefix[MaxNameLength]= "pic";
int PSPicCount= 0;
char PSFileName[MaxNameLength]= "";
FILE*PSFile= NULL;

/*:29*//*30:*/
#line 701 "MNB2LTX.W"

double PSPicWidth= 322.0;
double PSPicHeight= 200.0;
double PSAspect= 1.0;
int PSPreserveAspect= True;

/*:30*//*37:*/
#line 824 "MNB2LTX.W"

char TeXProlog1[]= 
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n"
"%% Mathematica Notebook -> LaTeX2e\n"
"%% "VERSION" from "__DATE__"\n"
"%% (c) 1995, J.-P. Kuska\n"
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n";
char TeXProlog2[]= 
"\\documentclass{article}\n"
"%%\n"
"\\usepackage{mathnb} %% notebook layout \n"
"%%%% Notebook text starts here\n"
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n"
"\\begin{document}\n\n";

const char TeXEpilog[]= 
"%%%% End of Notebook\n"
"\\end{document}\n";

/*:37*//*41:*/
#line 877 "MNB2LTX.W"

char*LastInputLine= NULL;

/*:41*/
#line 50 "MNB2LTX.W"

/*3:*/
#line 136 "MNB2LTX.W"

/*4:*/
#line 146 "MNB2LTX.W"

void ErrorMessage(int error_typ,char*function_name,
char*format,...)
{va_list arg;
char msg[2048];

va_start(arg,format);
vsprintf(msg,format,arg);
fprintf(stderr,"Error ...\n");
fprintf(stderr,"in %s :: %s\n",function_name,msg);
#if WINDOWS_MATHLINK
if(TeXFile){
fprintf(TeXFile,"%% ERROR ...\n");
fprintf(TeXFile,"%% ERROR  in %s :: %s\n",function_name,msg);
}
#endif
va_end(arg);
if(error_typ==CRITICAL){
fprintf(stderr,"Critical error - exit to system.\n");
exit(1);
}
}

/*:4*/
#line 137 "MNB2LTX.W"

/*5:*/
#line 170 "MNB2LTX.W"

char*TrimString(char*string)
{char*endp,*cp;

while(isspace(*string)&&*string)
MEMMOVE(string,string+1,strlen(string));
cp= string;
while(*cp)
if(isspace(*cp)&&*(cp+1)&&isspace(*(cp+1)))
MEMMOVE(cp,cp+1,strlen(cp));
else
cp++;
if(*string){
endp= string+strlen(string)-1;
while(isspace(*endp))
*(endp--)= '\0';
}
return string;
}

/*:5*/
#line 138 "MNB2LTX.W"

/*6:*/
#line 191 "MNB2LTX.W"

size_t N2L_GetFileSize(FILE*f)
{struct stat state;

fstat(fileno(f),&state);
return state.st_size;
}

/*:6*/
#line 139 "MNB2LTX.W"

/*7:*/
#line 199 "MNB2LTX.W"

int PtrLess(char*buffer,char*p1,char*p2)
{
while(buffer!=p1&&buffer!=p2)
buffer++;
if(buffer==p1)return True;
return False;
}

/*:7*/
#line 140 "MNB2LTX.W"


/*:3*/
#line 51 "MNB2LTX.W"

/*16:*/
#line 423 "MNB2LTX.W"

/*18:*/
#line 440 "MNB2LTX.W"

int FindCellDescriptor(char*celldescr)
{char*buffer;
char*pos;

buffer= InputBuffer+BufferPos;
pos= STRSTR(buffer,BeginCellDescriptor);
if(!pos)return False;
while(InputBuffer+BufferPos!=pos)
BufferPos++;
while(*pos!=*EndCellDescriptor){
*(celldescr++)= *(pos++);
BufferPos++;
}
*(celldescr++)= *(pos++);
BufferPos+= 2;
*celldescr= '\0';
return True;
}

/*:18*/
#line 424 "MNB2LTX.W"

/*19:*/
#line 464 "MNB2LTX.W"

int FindCellType(char*descr)
{int cell;

for(cell= MaxCells-1;cell>-1;cell--)
if(STRSTR(descr,CellTypes[cell].NBKey))
return cell;
return-1;
}

/*:19*/
#line 425 "MNB2LTX.W"

/*20:*/
#line 477 "MNB2LTX.W"

int EmptyCell(void)
{char*buffer;
char*nextcell;

buffer= InputBuffer+BufferPos;
nextcell= STRSTR(buffer,BeginCellDescriptor);
if(!nextcell)
nextcell= STRSTR(buffer,EndNotebook);
if(!nextcell||buffer==nextcell)return True;
while(isspace(*buffer))buffer++;
if((buffer-1)==nextcell)return True;
return False;
}

/*:20*/
#line 426 "MNB2LTX.W"

/*21:*/
#line 499 "MNB2LTX.W"

int InitialInCell(char*buffer)
{
return buffer==STRSTR(buffer,MathCommentClose);
}

/*:21*/
#line 427 "MNB2LTX.W"


/*:16*/
#line 52 "MNB2LTX.W"

#ifdef USE_MATHLINK
/*22:*/
#line 509 "MNB2LTX.W"

/*25:*/
#line 567 "MNB2LTX.W"

void OpenConnectionToMath(void)
{long int i,k;

MLEnv= MLInitialize((MLParametersPointer)NULL);
if(MLEnv==NULL){
ErrorMessage(NONCRITICAL,"OpenConnectionToMath",
"Can't initialise MathLink.");
CallMathematica= False;
return;
}
MLinkPtr= MLOpen(MathArgc,MathArgv);
if(MLinkPtr==NULL){
ErrorMessage(NONCRITICAL,"OpenConnectionToMath",
"Can't open MathLink.");
CallMathematica= False;
return;
}
#if !defined(WINDOWS_MATHLINK)   & !defined(OS2_MATHLINK)
k= 0;
while(!MLReady(MLinkPtr)&&k<100){
for(i= 0;i<WaitLoop;i++);
k++;
fprintf(stderr,"Waiting for MLink.\n");
}
if(!MLConnect(MLinkPtr))
ErrorMessage(NONCRITICAL,"OpenConnectionToMath",
"Can't get a connection.");
#endif
printf("Connection to Mathematica : ");
for(i= 0;i<MathArgc;i++)
printf("%s ",MathArgv[i]);
printf("\n");
}

/*:25*/
#line 510 "MNB2LTX.W"

/*26:*/
#line 603 "MNB2LTX.W"

void CloseConnectionToMath(void)
{
if(!CallMathematica)return;
MLPutFunction(MLinkPtr,"Exit",0L);
MLEndPacket(MLinkPtr);
if(MLinkPtr)MLClose(MLinkPtr);
if(MLEnv)MLDeinitialize(MLEnv);
}


/*:26*/
#line 511 "MNB2LTX.W"

/*27:*/
#line 614 "MNB2LTX.W"

int ConvertMathStringToTeX(char*minput)
{int pk;
char*texstr;
char*s1,*s2;

if(STRSTR(minput,NoInputForm))return False;
while(s1= strchr(minput,'\\'))
memmove(s1,s1+1,strlen(s1));
*MathTeXString= '\0';
fprintf(TeXFile,"%% Transfer to Mathematica\n"
"%% %s\n",minput);
MLPutFunction(MLinkPtr,"EvaluatePacket",1L);
MLPutFunction(MLinkPtr,"ToString",1L);
MLPutFunction(MLinkPtr,"TeXForm",1L);
MLPutFunction(MLinkPtr,"ToExpression",1L);
MLPutString(MLinkPtr,minput);
MLEndPacket(MLinkPtr);
MLFlush(MLinkPtr);
#ifdef WINDOWS_MATHLINK
while(!MLReady(MLinkPtr)){
Sleep(1000);
}
#endif
while((pk= MLNextPacket(MLinkPtr))!=RETURNPKT){
switch(pk){
case MESSAGEPKT:
MLGetSymbol(MLinkPtr,&s1);
MLGetString(MLinkPtr,&s2);
printf("%% Message %s :: %s \n",s1,s2);
fprintf(TeXFile,"%% Message %s :: %s \n",s1,s2);
MLDisownSymbol(MLinkPtr,s1);
MLDisownString(MLinkPtr,s2);
break;
case TEXTPKT:
MLGetString(MLinkPtr,&s1);
printf("%% Text: %s",s1);
fprintf(TeXFile,"%% Text: %s",s1);
MLDisownString(MLinkPtr,s1);
break;
case OUTPUTNAMEPKT:
case RETURNTEXTPKT:
MLGetString(MLinkPtr,&s1);
fprintf(TeXFile,"%% %s\n",s1);
fprintf(TeXFile,"%% %s\n",s1);
MLDisownString(MLinkPtr,s1);
break;
}
if(MLError(MLinkPtr)!=MLEOK||!pk){
ErrorMessage(NONCRITICAL,"ConvertMathStringToTeX"
"MathLink error %s.",MLErrorMessage(MLinkPtr));
if(MLError(MLinkPtr)==MLEDEAD||MLError(MLinkPtr)==MLECLOSED){
CallMathematica= False;
return False;
}
MLClearError(MLinkPtr);
}
MLNewPacket(MLinkPtr);
}

if(MLGetType(MLinkPtr)==MLTKSTR&&MLGetString(MLinkPtr,&texstr)){
strncpy(MathTeXString,texstr,TeXFormBufferSize);
MLDisownString(MLinkPtr,texstr);
}
return True;
}

/*:27*/
#line 512 "MNB2LTX.W"


/*:22*/
#line 54 "MNB2LTX.W"

#endif
/*42:*/
#line 882 "MNB2LTX.W"

int CheckQuestionMark(register char*lastinput)
{
lastinput= TrimString(lastinput);
if(*lastinput=='?')return True;
return False;
}


/*:42*/
#line 56 "MNB2LTX.W"

/*43:*/
#line 894 "MNB2LTX.W"

int CheckTeXForm(register char*lastinput)
{register char*p1;

lastinput= TrimString(lastinput);
if(STRSTR(lastinput,"TeXForm[")==lastinput)
return True;
if(STRSTR(lastinput,"TeXForm [")==lastinput)
return True;
if(STRSTR(lastinput,"TeXForm @")==lastinput)
return True;
if(STRSTR(lastinput,"TeXForm@")==lastinput)
return True;
if((STRSTR(lastinput,"//"))&&(STRSTR(lastinput,"TeXForm"))){
p1= strrchr(lastinput,'/')-1;
return(STRSTR(lastinput,"// TeXForm")==p1||
STRSTR(lastinput,"//TeXForm")==p1);
}
return False;
}

/*:43*/
#line 57 "MNB2LTX.W"

/*44:*/
#line 925 "MNB2LTX.W"

int ConvertCellToLaTeX(int ctype)
{register char*buffer,*pos;
char*posverb,*mi,*buffer1,*pfnt= NULL;
const char TeXEsc= '\\';
char*MathInput;
int len,endofnotebook= False;
int OutputIsTeX= False;

#if defined(WINDOWS_MATHLINK)
if(CallMathematica)
Sleep(100);
#endif
/*49:*/
#line 1090 "MNB2LTX.W"

buffer= InputBuffer+BufferPos;
pos= STRSTR(buffer,BeginCellDescriptor);
if(!pos){
pos= STRSTR(buffer,"\n"EndNotebook);
endofnotebook= True;
}
if(!pos){
ErrorMessage(NONCRITICAL,"ConvertCellToLaTeX",
"Can't find end of the Notebook.\n"
"Notebook probably broken.\n");
return True;
}

/*:49*/
#line 938 "MNB2LTX.W"

switch(ctype+1){
case CellText:
case CellSmallText:
pfnt= STRSTR(buffer,BeginFontSet);
fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
/*48:*/
#line 1068 "MNB2LTX.W"

switch(*CellTypes[ctype].TranslationType){
case'a':
case'A':
/*54:*/
#line 1200 "MNB2LTX.W"

while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
/*51:*/
#line 1127 "MNB2LTX.W"

if(*buffer=='{'||*buffer=='}'){
fprintf(TeXFile,"\\%c",*(buffer++));
continue;
}
if(*buffer=='\\'){
fprintf(TeXFile,"\\(\\backslash\\)");
buffer++;
continue;
}


/*:51*/
#line 1203 "MNB2LTX.W"

fputc(*(buffer++),TeXFile);
}

/*:54*/
#line 1072 "MNB2LTX.W"

break;
case'c':
case'C':
/*47:*/
#line 1060 "MNB2LTX.W"

if(pos){
while(buffer!=pos&&buffer!=EndBuffer&&buffer!=pfnt){
BufferPos++;
fputc(*(buffer++),TeXFile);
}
}

/*:47*/
#line 1076 "MNB2LTX.W"

break;
case'r':
case'R':
/*45:*/
#line 1025 "MNB2LTX.W"

if(pos){
while(buffer!=pos&&buffer!=EndBuffer&&buffer!=pfnt){
BufferPos++;
if(strchr(Special_TeX,*buffer)){
/*46:*/
#line 1037 "MNB2LTX.W"

switch(*buffer){
case'\\':
fprintf(TeXFile,"$\\backslash$");
break;
case'^':
fprintf(TeXFile,"{\\^{}}");
break;
case'<':
fprintf(TeXFile,"$<$");
break;
case'>':
fprintf(TeXFile,"$>$");
break;
default:
fprintf(TeXFile,"%c%c{}",TeXEsc,*buffer);
break;
}
buffer++;


/*:46*/
#line 1030 "MNB2LTX.W"

continue;
}
fputc(*(buffer++),TeXFile);
}
}

/*:45*/
#line 1080 "MNB2LTX.W"

break;
default:
ErrorMessage(NONCRITICAL,"ConvertCellToLaTeX",
"Can't figure out how to translate the characters in cell type %s.",
CellTypes[ctype].NBKey);
/*47:*/
#line 1060 "MNB2LTX.W"

if(pos){
while(buffer!=pos&&buffer!=EndBuffer&&buffer!=pfnt){
BufferPos++;
fputc(*(buffer++),TeXFile);
}
}

/*:47*/
#line 1086 "MNB2LTX.W"

break;
}

/*:48*/
#line 944 "MNB2LTX.W"

fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
break;
case CellInput:
if(InitialInCell(buffer)){
ctype= CellMathInitial-1;
buffer+= 3;
BufferPos+= 3;
pos= STRSTR(buffer,(char*)MathCommentOpen);
}
fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
/*50:*/
#line 1107 "MNB2LTX.W"

if(pos){
buffer1= buffer;
len= 0;
while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
len++;
/*51:*/
#line 1127 "MNB2LTX.W"

if(*buffer=='{'||*buffer=='}'){
fprintf(TeXFile,"\\%c",*(buffer++));
continue;
}
if(*buffer=='\\'){
fprintf(TeXFile,"\\(\\backslash\\)");
buffer++;
continue;
}


/*:51*/
#line 1114 "MNB2LTX.W"

fputc(*(buffer++),TeXFile);
}
if(LastInputLine)free(LastInputLine);
LastInputLine= (char*)malloc((len+1)*sizeof(char));
while(isspace(*buffer1))buffer1++;
len= 0;
while(buffer1!=pos&&buffer1!=EndBuffer)
LastInputLine[len++]= *(buffer1++);
LastInputLine[len]= '\0';
}

/*:50*/
#line 955 "MNB2LTX.W"

fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
break;
case CellOutput:
if(!CallMathematica||!CheckQuestionMark(LastInputLine)){
if((OutputIsTeX= CheckTeXForm(LastInputLine))||CallMathematica)
ctype= CellMathMath-1;
fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
/*52:*/
#line 1141 "MNB2LTX.W"

posverb= STRSTR(buffer,(char*)BeginOut2D);
len= 0;
while(buffer+len!=posverb)
len++;
mi= MathInput= (char*)malloc((len+1)*sizeof(char));
while(isspace(*buffer)){
buffer++;
BufferPos++;
}
while(buffer!=posverb){
*(mi++)= *(buffer++);
BufferPos++;
}
*mi= '\0';
while(isspace(*(mi-1))||isspace(*mi))
*(mi--)= '\0';
TrimString(MathInput);
buffer+= strlen(BeginOut2D);
BufferPos+= strlen(BeginOut2D);
#ifdef USE_MATHLINK
if(OutputIsTeX){
while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
fputc(*(buffer++),TeXFile);
}
}
else if(CallMathematica&&ConvertMathStringToTeX(MathInput)){
fprintf(TeXFile,"%s",MathTeXString);
while(buffer!=pos&&buffer!=EndBuffer){
buffer++;
BufferPos++;
}
}
else{
if(CallMathematica&&!STRSTR(MathInput,NoInputForm))
ErrorMessage(NONCRITICAL,"ConvertCellToLaTeX",
"%%Something wrong calling Mathematica with:\n%s\n"
"%%TeX will probably have some trouble here.",MathInput);
/*53:*/
#line 1189 "MNB2LTX.W"

if(OutputIsTeX){
while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
fputc(*(buffer++),TeXFile);
}
}
else{
/*54:*/
#line 1200 "MNB2LTX.W"

while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
/*51:*/
#line 1127 "MNB2LTX.W"

if(*buffer=='{'||*buffer=='}'){
fprintf(TeXFile,"\\%c",*(buffer++));
continue;
}
if(*buffer=='\\'){
fprintf(TeXFile,"\\(\\backslash\\)");
buffer++;
continue;
}


/*:51*/
#line 1203 "MNB2LTX.W"

fputc(*(buffer++),TeXFile);
}

/*:54*/
#line 1197 "MNB2LTX.W"

}

/*:53*/
#line 1180 "MNB2LTX.W"

}
#else
while('\n'==*EndBuffer)
EndBuffer--;
/*53:*/
#line 1189 "MNB2LTX.W"

if(OutputIsTeX){
while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
fputc(*(buffer++),TeXFile);
}
}
else{
/*54:*/
#line 1200 "MNB2LTX.W"

while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
/*51:*/
#line 1127 "MNB2LTX.W"

if(*buffer=='{'||*buffer=='}'){
fprintf(TeXFile,"\\%c",*(buffer++));
continue;
}
if(*buffer=='\\'){
fprintf(TeXFile,"\\(\\backslash\\)");
buffer++;
continue;
}


/*:51*/
#line 1203 "MNB2LTX.W"

fputc(*(buffer++),TeXFile);
}

/*:54*/
#line 1197 "MNB2LTX.W"

}

/*:53*/
#line 1185 "MNB2LTX.W"

#endif
free(MathInput);

/*:52*/
#line 963 "MNB2LTX.W"

fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
break;
}
else{
ctype= CellPrint-1;
goto NoMathTranslation;
}
case CellMessage:
case CellPrint:
case CellInformation:
NoMathTranslation:pfnt= STRSTR(buffer,BeginFontSet);
fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
/*55:*/
#line 1207 "MNB2LTX.W"

posverb= STRSTR(buffer,BeginOut2D);
if(posverb&&PtrLess(buffer,posverb,pos)){
while(buffer!=posverb){
buffer++;
BufferPos++;
}
buffer+= strlen(BeginOut2D);
BufferPos+= strlen(BeginOut2D);
}
if(buffer!=pos){
/*54:*/
#line 1200 "MNB2LTX.W"

while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
/*51:*/
#line 1127 "MNB2LTX.W"

if(*buffer=='{'||*buffer=='}'){
fprintf(TeXFile,"\\%c",*(buffer++));
continue;
}
if(*buffer=='\\'){
fprintf(TeXFile,"\\(\\backslash\\)");
buffer++;
continue;
}


/*:51*/
#line 1203 "MNB2LTX.W"

fputc(*(buffer++),TeXFile);
}

/*:54*/
#line 1218 "MNB2LTX.W"

}

/*:55*/
#line 976 "MNB2LTX.W"

fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
break;

case CellPostScript:
if(buffer==pos){
BufferPos--;
break;
}
while(isspace(*buffer)&&buffer!=pos){
buffer++;
BufferPos++;
}
if(buffer==pos)break;
fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
/*33:*/
#line 764 "MNB2LTX.W"

sprintf(PSFileName,"%s%d.ps",PSFilePrefix,PSPicCount++);
printf("Saving picture %s\n",PSFileName);
/*31:*/
#line 710 "MNB2LTX.W"

{char*basp;

basp= STRSTR(buffer,BeginAspectRatio);
if(basp){
sscanf(basp,BeginAspectRatio": %lg",&PSAspect);
if(PSPreserveAspect)
PSPicHeight= PSAspect*PSPicWidth;
}
else
PSAspect= 1.0;
}

/*:31*/
#line 767 "MNB2LTX.W"

PSFile= fopen(PSFileName,"w");
if(!PSFile)
ErrorMessage(CRITICAL,"ConvertCellToLaTeX",
"Can't open PostScript file %s.",PSFileName);
fprintf(PSFile,
"%%!PS-Adobe-2.0 EPSF-2.0\n"
"%%%%BoundingBox: 0 0 %.0f %.0f\n"
"%%%%Title: %s\n"
"%%%%Creator: mnb2ltx "VERSION
"\n%%%%CreationDate: \n"
"%%%%EndComments\n"
"%% File extracted from Mathematica Notebook :%s\n"
"%% File is used by TeX document : %s\n",
PSPicWidth,PSPicHeight,PSFileName,NotebookName,TeXFileName);
fprintf(PSFile,
"%%%%BeginProcSet: %s\n",PSPrologFile);
fprintf(PSFile,
"/Mathdict 150 dict def\n"
"Mathdict begin\n"
"/Mwidth  %.2f def\n"
"/Mheight %.2f def\n"
"/Mnodistort %s def\n",PSPicWidth,PSPicHeight,
(PSPreserveAspect?"true":"false"));
/*34:*/
#line 793 "MNB2LTX.W"

{FILE*pfile;
char*buffer;
size_t fsize;

pfile= fopen(PSPrologFile,"r");
if(!pfile)
ErrorMessage(CRITICAL,"ConvertCellToLaTeX",
"Can't find prolog file \"%s\" for picture \"%s\".",
PSPrologFile,PSFileName);
fsize= N2L_GetFileSize(pfile);
buffer= (char*)malloc(fsize*sizeof(char));
fsize= fread(buffer,sizeof(char),fsize,pfile);
fwrite(buffer,sizeof(char),fsize,PSFile);
free(buffer);
fclose(pfile);
}

/*:34*/
#line 791 "MNB2LTX.W"


/*:33*/
#line 991 "MNB2LTX.W"

/*35:*/
#line 812 "MNB2LTX.W"

pos= STRSTR(buffer,MathPSEnd);
while(buffer!=pos){
fputc(*(buffer++),PSFile);
BufferPos++;
}

/*:35*/
#line 992 "MNB2LTX.W"

fprintf(TeXFile,"\\includegraphics[width=\\MathPicX]{%s}\n",PSFileName);
/*36:*/
#line 819 "MNB2LTX.W"

fprintf(PSFile,"%s\nend\nshowpage\n",MathPSEnd);
fclose(PSFile);

/*:36*/
#line 994 "MNB2LTX.W"

fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
break;
case CellGraphics:break;
default:
pfnt= STRSTR(buffer,BeginFontSet);
switch(*CellTypes[ctype].TranslationType){
case'r':
case'R':
fprintf(TeXFile,"%% Cell convertet with replacement.\n");
break;
case'a':
case'A':
fprintf(TeXFile,"%% Cell convertet for alltt-evironment.\n");
break;
case'c':
case'C':
fprintf(TeXFile,"%% Cell contens is copyed.\n");
break;
}
fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
/*48:*/
#line 1068 "MNB2LTX.W"

switch(*CellTypes[ctype].TranslationType){
case'a':
case'A':
/*54:*/
#line 1200 "MNB2LTX.W"

while(buffer!=pos&&buffer!=EndBuffer){
BufferPos++;
/*51:*/
#line 1127 "MNB2LTX.W"

if(*buffer=='{'||*buffer=='}'){
fprintf(TeXFile,"\\%c",*(buffer++));
continue;
}
if(*buffer=='\\'){
fprintf(TeXFile,"\\(\\backslash\\)");
buffer++;
continue;
}


/*:51*/
#line 1203 "MNB2LTX.W"

fputc(*(buffer++),TeXFile);
}

/*:54*/
#line 1072 "MNB2LTX.W"

break;
case'c':
case'C':
/*47:*/
#line 1060 "MNB2LTX.W"

if(pos){
while(buffer!=pos&&buffer!=EndBuffer&&buffer!=pfnt){
BufferPos++;
fputc(*(buffer++),TeXFile);
}
}

/*:47*/
#line 1076 "MNB2LTX.W"

break;
case'r':
case'R':
/*45:*/
#line 1025 "MNB2LTX.W"

if(pos){
while(buffer!=pos&&buffer!=EndBuffer&&buffer!=pfnt){
BufferPos++;
if(strchr(Special_TeX,*buffer)){
/*46:*/
#line 1037 "MNB2LTX.W"

switch(*buffer){
case'\\':
fprintf(TeXFile,"$\\backslash$");
break;
case'^':
fprintf(TeXFile,"{\\^{}}");
break;
case'<':
fprintf(TeXFile,"$<$");
break;
case'>':
fprintf(TeXFile,"$>$");
break;
default:
fprintf(TeXFile,"%c%c{}",TeXEsc,*buffer);
break;
}
buffer++;


/*:46*/
#line 1030 "MNB2LTX.W"

continue;
}
fputc(*(buffer++),TeXFile);
}
}

/*:45*/
#line 1080 "MNB2LTX.W"

break;
default:
ErrorMessage(NONCRITICAL,"ConvertCellToLaTeX",
"Can't figure out how to translate the characters in cell type %s.",
CellTypes[ctype].NBKey);
/*47:*/
#line 1060 "MNB2LTX.W"

if(pos){
while(buffer!=pos&&buffer!=EndBuffer&&buffer!=pfnt){
BufferPos++;
fputc(*(buffer++),TeXFile);
}
}

/*:47*/
#line 1086 "MNB2LTX.W"

break;
}

/*:48*/
#line 1015 "MNB2LTX.W"

fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
}
return endofnotebook;
}

/*:44*/
#line 58 "MNB2LTX.W"

/*56:*/
#line 1221 "MNB2LTX.W"

void ExitNotebook2TeX(void)
{
#ifdef USE_MATHLINK
if(CallMathematica)
CloseConnectionToMath();
#endif
if(TeXFile)fclose(TeXFile);
}

/*:56*/
#line 59 "MNB2LTX.W"

/*57:*/
#line 1232 "MNB2LTX.W"

int main(int argc,char*argv[]){
CmdArgLst*cmdln;
char celldescr[MaxNameLength];
int endnb,i;
int cellType;

atexit(ExitNotebook2TeX);
/*2:*/
#line 94 "MNB2LTX.W"

cmdln= DeclareCmdArg("fout",CMD_STRING,&TeXFileName,
"LaTeX2e file name.");
cmdln= AppendCmdArg(DeclareCmdArg("fin",CMD_STRING,&NotebookName,
"input Mathematica notebook file ."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("psprfx",CMD_STRING,&PSFilePrefix,
"prefix for the produced PostScript files."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("pspro",CMD_STRING,&PSPrologFile,
"file of Mathematica 2.2 PostScript prolog."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("paspect",CMD_SWITCH,&PSPreserveAspect,
"Preserve aspect ratio of the exported pictures."),cmdln);

cmdln= AppendCmdArg(DeclareCmdArg("pwidth",CMD_DOUBLE,&PSPicWidth,
"width of the extracted PostScript pictures in bp."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("pheight",CMD_DOUBLE,&PSPicHeight,
"height of the extracted PostScript pictures in bp."),cmdln);

cmdln= AppendCmdArg(DeclareCmdArg("ct",CMD_STRING,&CellTypes[CellText-1].TranslationType,
"convert text cell:\n                       replace  $%%{}\\.\n"
"                       alltt\n"
"                       copy"),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("cs1",CMD_STRING,&CellTypes[CellSpecial1-1].TranslationType,
"convert text special1, see text for arguments."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("cs2",CMD_STRING,&CellTypes[CellSpecial2-1].TranslationType,
"convert text special2, see text for arguments."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("cs3",CMD_STRING,&CellTypes[CellSpecial3-1].TranslationType,
"convert text special3, see text for arguments."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("cs4",CMD_STRING,&CellTypes[CellSpecial4-1].TranslationType,
"convert text special4, see text for arguments."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("cs5",CMD_STRING,&CellTypes[CellSpecial5-1].TranslationType,
"convert text special5, see text for arguments."),cmdln);

#ifdef USE_MATHLINK
cmdln= AppendCmdArg(DeclareCmdArg("mout",CMD_SWITCH,&CallMathematica,
"+mout call Mathematica via MathLink to produce TeXForm in Out[]-cells."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("linkname",CMD_STRING,&LinkName,
"option passed to MathLink ."),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("linkmode",CMD_STRING,&LinkMode,
"option passed to MathLink ."),cmdln);
#endif

/*:2*/
#line 1240 "MNB2LTX.W"

if(argc>1)
cmdln= ScanCommandline(cmdln,argc,argv);
if(argc<=1||!(*NotebookName)){
HelpCmdArg(BANNER,cmdln);
exit(1);
}
/*10:*/
#line 371 "MNB2LTX.W"

for(i= CellTitle-1;i<CellText-1;i++)
strcpy(CellTypes[i].TranslationType,CellTypes[CellText-1].TranslationType);
strcpy(CellTypes[CellSmallText-1].TranslationType,
CellTypes[CellText-1].TranslationType);


/*:10*/
#line 1247 "MNB2LTX.W"

/*32:*/
#line 738 "MNB2LTX.W"

if(!CmdArgGiven("pspro",cmdln)){
char tmp[MaxNameLength],*c1,*c2,*c3;

c1= tmp;
c2= argv[0];
while(*c2)
*(c1++)= tolower(*(c2++));
*c1= '\0';

c1= tmp;
while(c2= STRSTR(c1,PROGNAME)){
c3= c2;
c1= c2+1;
}
*c3= '\0';
c1= tmp;
c2= argv[0];


while(*c1)
*(c1++)= *(c2++);
strcat(tmp,PSPrologFile);
strcpy(PSPrologFile,tmp);
}

/*:32*/
#line 1248 "MNB2LTX.W"

printf(BANNER);
if(!STRSTR(NotebookName,NBExtension))strcat(NotebookName,NBExtension);
if(!*TeXFileName)/*38:*/
#line 843 "MNB2LTX.W"

{char*posex,*tn,*nn;

posex= STRSTR(NotebookName,NBExtension);
tn= TeXFileName;
nn= NotebookName;
while(nn!=posex)
*(tn++)= *(nn++);
*tn= '\0';
strcat(TeXFileName,".tex");
}

/*:38*/
#line 1251 "MNB2LTX.W"

NBFile= fopen(NotebookName,"rt");
if(!NBFile)
ErrorMessage(CRITICAL,"main",
"Can't find notebook \"%s\".",NotebookName);
/*39:*/
#line 855 "MNB2LTX.W"

TeXFile= fopen(TeXFileName,"w");
if(!TeXFile)
ErrorMessage(CRITICAL,"main",
"Can't open output file \"%s\".",TeXFileName);
fprintf(TeXFile,TeXProlog1,PSPrologFile);
fprintf(TeXFile,"%% the document was generated by the command line:\n"
"%% mnb2ltx ");
for(i= 1;i<argc;i++)
fprintf(TeXFile," %s ",argv[i]);
fprintf(TeXFile,"\n");
fprintf(TeXFile,TeXProlog2,PSPrologFile);
fprintf(TeXFile,"\\setlength{\\MathPicX}{%lg bp}\n",PSPicWidth);


/*:39*/
#line 1256 "MNB2LTX.W"

/*15:*/
#line 408 "MNB2LTX.W"

/*13:*/
#line 394 "MNB2LTX.W"

BufferCount= BufferSize= N2L_GetFileSize(NBFile);
InputBuffer= (char*)CALLOC(BufferSize,sizeof(char));
MEMSET(InputBuffer,'\0',BufferSize);
BufferPos= 0;

/*:13*/
#line 409 "MNB2LTX.W"

BufferSize= fread(InputBuffer,sizeof(char),BufferSize,NBFile);
if(!BufferSize)
ErrorMessage(CRITICAL,"main",
"Error reading input notebook %s.",NotebookName);
if(feof(NBFile)){
fclose(NBFile);
NBFile= NULL;
}
while(InputBuffer[BufferPos++]!=']');
EndBuffer= strstr(InputBuffer+BufferPos,EndNotebook);
*(EndBuffer+strlen(EndNotebook))= '\0';

/*:15*/
#line 1257 "MNB2LTX.W"

printf("Converting file \"%s\" -> \"%s\"\n",NotebookName,TeXFileName);
#ifdef USE_MATHLINK
if(CallMathematica)
OpenConnectionToMath();
#endif
while(FindCellDescriptor(celldescr)&&BufferPos<BufferSize){
cellType= FindCellType(celldescr);
if(cellType>-1&&!EmptyCell()){
endnb= ConvertCellToLaTeX(cellType);
fflush(TeXFile);
}
if(endnb)break;
}
/*40:*/
#line 870 "MNB2LTX.W"

fprintf(TeXFile,"%s",TeXEpilog);
fclose(TeXFile);

/*:40*/
#line 1271 "MNB2LTX.W"

/*14:*/
#line 400 "MNB2LTX.W"

free(InputBuffer);
if(LastInputLine)free(LastInputLine);

/*:14*/
#line 1272 "MNB2LTX.W"

#ifdef USE_MATHLINK
if(CallMathematica){
CloseConnectionToMath();
CallMathematica= False;
}
#endif
return 0;
}


/*:57*/
#line 60 "MNB2LTX.W"


/*:1*/
