\def\Math{{\it Mathematica}}
\def\ML{{\it MathLink}}
\def\LaTeX{La\TeX}
\def\cmdarg#1{{$\langle$\it{}#1$\rangle$}}

@s MLINK int
@s MLEnvironment int
@s MLYieldFunctionObject int
@s MLYieldFunctionType int
@s MLCB int
@s FARPROC int
@s MSG int

@ \Math-Notebook  to \LaTeX\ The program \.{mnb2ltx} convert a
\Math-Notebook to a file for \LaTeX.

@d VERSION  "Version 1.0beta"
@d BANNER   "Mathematica 2.2 Notebook -> LaTeX2e\n"@|
                 " (c) 1995 J.-P. Kuska "VERSION" from "__DATE__"\n"@|
                 " MathLink copyright 1995 Wolfram Research, Inc.\n"@|
@s CmdArgLst int
@d True  (1)
@d False (0)
@d PROGNAME  "mnb2ltx"
@c
#if !defined(__WIN32__) & !defined(__WATCOMC__) & defined(WINDOWS_MATHLINK)
#  define CALLOC farcalloc
#  define MALLOC farmalloc
#  define FREE   farfree
#  define MEMSET _fmemset
#  define STRSTR _fstrstr
#  define MEMMOVE _fmemmove
#elif defined(WINDOWS_MATHLINK) & defined(__WATCOMC__)
#  define CALLOC _fcalloc
#  define MALLOC _fmalloc
#  define FREE   _ffree
#  define MEMSET _fmemset
#  define STRSTR _fstrstr
#  define MEMMOVE _fmemmove
#else
#  define CALLOC calloc
#  define MALLOC malloc
#  define FREE free
#  define MEMSET memset
#  define STRSTR strstr
#  define MEMMOVE memmove
#endif
@<Header@>@;
@<Cell type@>@;
@<Global values@>@;
@<Utilities@>@;
@<Notebook scaning@>@;
#ifdef USE_MATHLINK
@<\ML\ functions@>@;
#endif
@<Check last input line for a question@>@;
@<Check input for \.{TeXForm}@>@;
@<Convert the cell contens to \LaTeX@>@;
@<Exit function@>@;
@<Main@>@;

@* Command line options.
\.{mnb2ltx} is usualy called as

{\tt mnb2ltx -fin} {\it notebook} {\tt -fout} {\it \LaTeX{}file}

but mutch more switches are possible.
\halign{\qquad \tt #  &\qquad  # \hfill\cr
\noalign{\smallskip\hrule\smallskip\hrule\smallskip}
{\rm switch}    &  meaning \cr
\noalign{\smallskip\hrule\smallskip}
\noalign{\bf Files:}
-fin \cmdarg{string\.{[.ma]}}   & the name of the notebook file\cr
-fout \cmdarg{string}           & the name of the tex file, optional\cr
\noalign{\bf Character conversion in cells:}
-ct \cmdarg{string}          & convert text cells as: \cr
                             & \qquad |"copy"|    no conversion \cr
                             & \qquad |"replace"| repalce special \TeX\  character \cr
                             & \qquad |"alltt"|   replace |"{"|, |"}"| and |"\\"|.\cr
-cs{\it i} \cmdarg{string}          & convert special {\it i} cells \cr
\noalign{\bf PostScript:}
-psprfx \cmdarg{string}      & the prefix for the PostScript files, optional \.{pic}\cr
-pspro \cmdarg{string}       & the PostScript prolog file, optional \.{mathps.pro}\cr
-pwidth  \cmdarg{double}     & the picture width in bp\cr
-pheight \cmdarg{double}     & the picture height in bp\cr
\noalign{\bf MathLink}
+mout/-mout             & call \Math\ for the generation of {\tt TeXForm} in
                                                                  the output cells \cr
-linkname \cmdarg{string}         & \ML\ name, on unix \.{math -mathlink} \cr
-linkmode \cmdarg{string}  & \ML\ mode, typical launch \cr
\noalign{\smallskip\hrule\smallskip\hrule\bigskip}
}

@<Declare the comand line options@>=
  cmdln=DeclareCmdArg("fout",CMD_STRING,&TeXFileName,
			  "LaTeX2e file name.");
  cmdln=AppendCmdArg(DeclareCmdArg("fin",CMD_STRING,&NotebookName,
           "input Mathematica notebook file ."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("psprfx",CMD_STRING,&PSFilePrefix,
           "prefix for the produced PostScript files."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("pspro",CMD_STRING,&PSPrologFile,
           "file of Mathematica 2.2 PostScript prolog."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("paspect",CMD_SWITCH,&PSPreserveAspect,
                "Preserve aspect ratio of the exported pictures."),cmdln);

  cmdln=AppendCmdArg(DeclareCmdArg("pwidth",CMD_DOUBLE,&PSPicWidth,
                "width of the extracted PostScript pictures in bp."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("pheight",CMD_DOUBLE,&PSPicHeight,
                          "height of the extracted PostScript pictures in bp."),cmdln);

  cmdln=AppendCmdArg(DeclareCmdArg("ct",CMD_STRING,&CellTypes[CellText-1].TranslationType,@|
           "convert text cell:\n                       replace  $%%{}\\.\n"@|
                               "                       alltt\n"@|
                               "                       copy"),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("cs1",CMD_STRING,&CellTypes[CellSpecial1-1].TranslationType,@|
           "convert text special1, see text for arguments."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("cs2",CMD_STRING,&CellTypes[CellSpecial2-1].TranslationType,@|
                "convert text special2, see text for arguments."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("cs3",CMD_STRING,&CellTypes[CellSpecial3-1].TranslationType,@|
           "convert text special3, see text for arguments."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("cs4",CMD_STRING,&CellTypes[CellSpecial4-1].TranslationType,@|
                "convert text special4, see text for arguments."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("cs5",CMD_STRING,&CellTypes[CellSpecial5-1].TranslationType,@|
		"convert text special5, see text for arguments."),cmdln);

#ifdef USE_MATHLINK
  cmdln=AppendCmdArg(DeclareCmdArg("mout",CMD_SWITCH,&CallMathematica,
           "+mout call Mathematica via MathLink to produce TeXForm in Out[]-cells."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("linkname",CMD_STRING,&LinkName,
           "option passed to MathLink ."),cmdln);
  cmdln=AppendCmdArg(DeclareCmdArg("linkmode",CMD_STRING,&LinkMode,
                "option passed to MathLink ."),cmdln);
#endif

@* Utilities.
@<Utilities@>=
@<Error message function@>@;
@<Remove the leading and trailing spaces@>@;
@<Get file size@>@;
@<Less for pointer@>@;

@ This function will report the errors during the run.
@d  CRITICAL    (1)
@d  NONCRITICAL (0)

@<Error message function@>=
void ErrorMessage(int error_typ,char *function_name,
                  char *format,...)
 { va_list arg;
        char msg[2048];

   va_start(arg,format);
        vsprintf(msg, format, arg);
        fprintf(stderr,"Error ...\n");
        fprintf(stderr,"in %s :: %s\n", function_name, msg);
#if WINDOWS_MATHLINK
        if(TeXFile) {
          fprintf(TeXFile,"%% ERROR ...\n");
          fprintf(TeXFile,"%% ERROR  in %s :: %s\n",function_name,msg);
         }
#endif
        va_end(arg);
        if (error_typ==CRITICAL) {
          fprintf(stderr,"Critical error - exit to system.\n");
          exit(1);
	 }
 }

@ Remove space characters at the top and the end of the string.
@<Remove the leading and trailing spaces@>=
char  *TrimString(char  *string)
{ char  *endp,  *cp;

  while(isspace(*string) && *string) /* remove spaces at the top */
    MEMMOVE(string,string+1,strlen(string));
  cp=string;
  while(*cp) /* remove double inner spaces */
    if(isspace(*cp) && *(cp+1) && isspace(*(cp+1)))
      MEMMOVE(cp,cp+1,strlen(cp));
    else
      cp++;
  if(*string) {
    endp=string+strlen(string)-1; /* remove spaces at the end */
    while(isspace(*endp))
      *(endp--)='\0';
   }
  return string;
}

@ Get the size of a open file.
@<Get file size@>=
size_t N2L_GetFileSize(FILE *f)
{ struct stat state;

  fstat(fileno(f),&state);
  return state.st_size;
}

@ @<Less for pointer@>=
int PtrLess(char *buffer, char *p1, char *p2)
{
  while(buffer!=p1 && buffer!=p2)
    buffer++;
  if(buffer==p1) return True;
  return False;
}

@ The \Math-notebooks have diffent cells here we define some short cuts
for the cell types. For every kind of cell we have to define the key
that is used in the notebook and at least a \LaTeX introduction command
and a closing command. Clearly input, output and postscript cells need
additional work.
@d CellTitle         1
@d CellSubTitle      2
@d CellSubSubTitle   3
@d CellSection       4
@d CellSubSection    5
@d CellSubSubSection 6
@d CellText          7
@d CellSmallText     8
@d CellInput         9
@d CellOutput        10
@d CellMessage       11
@d CellPrint         12
@d CellGraphics      13
@d CellPostScript    14
@d CellInformation   15
@d CellSpecial1      16
@d CellSpecial2      17
@d CellSpecial3      18
@d CellSpecial4      19
@d CellSpecial5      20
@d CellHelp          21
@d CellMathMath      22
@d CellMathInitial   23
@<Cell type@>=
typedef struct NotebookCell { int what;
                              char *NBKey;
                              char TranslationType[64];
                              char *TeXProlog;
                              char *TeXEpilog;
                             } NotebookCell;

@ Now we can set up the database for the notebook cells
@d COPY    "copy"
@d ALLTT   "alltt"
@d REPLACE "replace"
@d UNUSED  "unused"
@d MaxCells 21
@<Global values@>=
NotebookCell CellTypes[MaxCells+2]=
{{CellTitle,
  "title",
  REPLACE,
  "\\MathTitle{",
  "}\n"},@|
 {CellSubTitle,
  "subtitle",
  REPLACE,
  "\\MathSubTitle{",
  "}\n"},@|
 {CellSubSubTitle,
  "subsubtitle",
  REPLACE,
  "\\MathSubSubTitle{",
  "}\n"},@|
 {CellSection,
  "section",
  REPLACE,
  "\\section{",
  "}\n\n"},@|
 {CellSubSection,
  "subsection",
  REPLACE,
  "\\subsection{",
  "}\n\n"},@|
 {CellSubSubSection,
  "subsubsection",
  REPLACE,
  "\\subsubsection{",
  "}\n\n"},@|
 {CellText,
  "text",
  COPY,
  "",
  "\n\\par\n"},@|
 {CellSmallText,
  "smalltext",
  COPY,
  "\\begin{MathSmall}\n",
  "\n\\end{MathSmall}\n"},@|
 {CellInput,
  "input",
  UNUSED,
  "\\begin{MathIn}\n",
  "\n\\end{MathIn}\n"},@|
 {CellOutput,
  "output",
  UNUSED,
  "\\begin{MathOut}\n",
  "\n\\end{MathOut}\n"},@|
 {CellMessage,
  "message",
  UNUSED,
  "\\begin{MathMessage}\n",
  "\n\\end{MathMessage}\n"},@|
 {CellPrint,
  "print",
  UNUSED,
  "\\begin{MathPrint}\n",
  "\n\\end{MathPrint}\n"},@|
 {CellGraphics,
  "graphics",
  UNUSED,
  "\\begin{MathGraph}\n",
  "\\end{MathGraph}\n"},@|
 {CellPostScript,
  "postscript",
  UNUSED,
  "\\begin{MathGraph}\n",
  "\\end{MathGraph}\n"},@|
 {CellInformation,
  "info",
  UNUSED,
  "\\begin{MathInfo}\n",
  "\n\\end{MathInfo}\n"},@|
 {CellSpecial1,
  "special1",
  REPLACE,
  "\\begin{MathSpecial1}\n",
  "\n\\end{MathSpecial1}\n"},@|
 {CellSpecial2,
  "special2",
  REPLACE,
  "\\begin{MathSpecial2}\n",
  "\n\\end{MathSpecial2}\n"},@|
 {CellSpecial3,
  "special3",
  REPLACE,
  "\\begin{MathSpecial3}\n",
  "\n\\end{MathSpecial3}\n"},@|
 {CellSpecial4,
  "special4",
  REPLACE,
  "\\begin{MathSpecial4}\n",
  "\n\\end{MathSpecial4}\n"},@|
 {CellSpecial5,
  "special5",
  REPLACE,
  "\\begin{MathSpecial5}\n",
  "\n\\end{MathSpecial5}\n"},@|
 {CellHelp,
  "help",
  REPLACE,
  "",
  "\n\\par\n"},@|
 {CellMathMath,
   "",
   UNUSED,
   "\\MathOutLabel\n\\begin{displaymath}\n",
   "\n\\end{displaymath}\n"},
 {CellMathInitial,
  "",
  UNUSED,
  "\\begin{MathInInit}\n",
  "\\end{MathInInit}\n"}
};

@ The replacement for all text like cells is the same. so we copy the
  replacemt entry form the text |CellText| to all other text cells.
@<Update replacement for text cells@>=
for(i=CellTitle-1; i<CellText-1; i++)
  strcpy(CellTypes[i].TranslationType, CellTypes[CellText-1].TranslationType);
strcpy(CellTypes[CellSmallText-1].TranslationType,
         CellTypes[CellText-1].TranslationType);


@* Input notebook file and \LaTeX\ file.
@d MaxNameLength 256
@d NBExtension   ".ma"
@<Global values@>=
char NotebookName[MaxNameLength]="";
FILE *NBFile=NULL;
char TeXFileName[MaxNameLength]="";
FILE *TeXFile;

@* Input buffer. At first we make a text buffer of 64 kByte.
@<Global values@>=
char  *InputBuffer, *EndBuffer;
long int BufferSize = 16384;
long int BufferCount=0;
long int BufferPos=0;

@ @<Allocate input buffer@>=
BufferCount=BufferSize=N2L_GetFileSize(NBFile);
InputBuffer=(char  *)CALLOC(BufferSize,sizeof(char));
MEMSET(InputBuffer,'\0',BufferSize);
BufferPos=0;

@ @<Free input buffer@>=
free(InputBuffer);
if(LastInputLine) free(LastInputLine);

@ Since the |fread| will not produce a propper string we have to skip
  over the header search for the end of the notebook |"^*)"| and append
  a |'\0'| character.

@<Fill the input buffer@>=
 @<Allocate input buffer@>@;
 BufferSize=fread(InputBuffer,sizeof(char),BufferSize,NBFile);
 if(!BufferSize)
   ErrorMessage(CRITICAL,"main",@|
     "Error reading input notebook %s.",NotebookName);
 if(feof(NBFile)) {
   fclose(NBFile);
   NBFile=NULL;
  }
 while( InputBuffer[BufferPos++] !=  ']'); /* skip over the information part */
 EndBuffer=strstr(InputBuffer+BufferPos,EndNotebook);
 *(EndBuffer+strlen(EndNotebook))='\0';

@* Scan the notebook.
@<Notebook scaning@>=
@<Get the cell descriptor line@>@;
@<Find the type of the cell@>@;
@<Reconnais an empty cell@>@;
@<Identify an initialisation cell@>@;

@ Every notebook cell starts with a single line, the line has the shape

\.{:[font = $\langle${\it cell style}$\rangle$; $\ldots$ ]}

@ Search in the |InputBuffer| for a notbook cell descriptor.
  If an descriptor is found |FindCellDescriptor| returns
  |True| otherwise |False|.

@d BeginCellDescriptor  "\n:["
@d EndCellDescriptor    "]"
@d EndNotebook          "^*)"
@<Get the cell descriptor line@>=
int FindCellDescriptor(char *celldescr)
{ char  *buffer;
  char  *pos;

  buffer=InputBuffer+BufferPos;
  pos=STRSTR(buffer,BeginCellDescriptor);
  if(!pos) return False;
  while (InputBuffer+BufferPos!=pos)
    BufferPos++;            /* increment the |BufferCount| */
  while(*pos!=*EndCellDescriptor) {
    *(celldescr++)=*(pos++); /* copy the descriptor */
    BufferPos++;
   }
  *(celldescr++) =*(pos++); /* copy the |EndCellDescriptor| */
  BufferPos+=2; /* skip over the |"]"| and the return */
  *celldescr='\0';
  return True;
}

@ From the cell descriptor line it is easy to find out what kind
of cell follows. We must search backward so that \.{subsubsection}
is found first otherwise \.{section} and \.{subsection} matches the
string first and \.{subsubsection} is never found.
@<Find the type of the cell@>=
int FindCellType(char *descr)
{ int cell;

  for(cell=MaxCells-1; cell>-1; cell--)
    if(STRSTR(descr,CellTypes[cell].NBKey))
      return cell;
  return -1;
}

@ A common problem in notebooks are empty cells, since the conversion
function expect nonempty cells we have to check for empty cells and skip
over.
@<Reconnais an empty cell@>=
int EmptyCell(void)
{ char  *buffer;
  char  *nextcell;

  buffer=InputBuffer+BufferPos;
  nextcell=STRSTR(buffer,BeginCellDescriptor);
  if(!nextcell)
    nextcell=STRSTR(buffer,EndNotebook);
  if(!nextcell || buffer==nextcell) return True;
  while(isspace(*buffer)) buffer++;
  if ((buffer-1) ==nextcell) return True;
  return False;
}

@ Initialisation cells close the \Math-comment at the begin of the
  notebook with |"*)"| and opens again the \Math-comment at the end
  to identify an initialisation cell we need only to look for the closing
  of the comment.
@d MathCommentClose "*)"
@d MathCommentOpen  "(*"

@<Identify an initialisation cell@>=
int InitialInCell(char *buffer)
{
  return buffer==STRSTR(buffer,MathCommentClose);
}

@* \ML. This will setup the basic functions to convert the \.{InputForm}
of the \.{Out[]}-cells into \TeX. If the equations are not very short this
option, activated with the \.{+mout} switch, need some additional work by hand
to break the formulas over the lines.
@<\ML\ functions@>=
@<Open the connection to \Math@>@;
@<Close the communication with \Math@>@;
@<Send a string to \Math\  and keep the \.{TeXForm}@>@;

@ Variables for the command line switches and the communication with \Math.
|MathTeXString| will hold the result from \Math, we allocate |TeXFormBufferSize|
bytes for it, this will be more than ever needed. If the \Math-output will
be longer than 32 kByte somthing may be extreamly wrong.

@d MaxMathArgc 8
@d TeXFormBufferSize   16384

@ @<Global values@>=
int CallMathematica=False;
int MLDone=0;
char LinkMode[MaxNameLength]="launch";

#if defined( WINDOWS_MATHLINK)
char LinkName[MaxNameLength]="c:\\wnmath22\\math.exe -mathlink";
char LinkProtocol[MaxNameLength]="tcp";

long int    MathArgc=6L;

char  *MathArgv[MaxMathArgc+1]=@|
  {"-linkname",LinkName,@|
   "-linkmode",LinkMode,@|
   "-linkprotocol",LinkProtocol,@|
    NULL};
#elif defined(OS2_MATHLINK)
char LinkName[MaxNameLength]="math.cmd -mathlink";
char LinkProtocol[MaxNameLength]="";

long int    MathArgc=4L;

char  *MathArgv[MaxMathArgc+1]=@|
  {"-linkname",LinkName,@|
   "-linkmode",LinkMode,@|
    NULL};
#else
char LinkName[MaxNameLength]="math -mathlink";
char LinkProtocol[MaxNameLength]="";

long int    MathArgc=4L;
char  *MathArgv[MaxMathArgc+1]=@|
  {"-linkname",LinkName,@|
   "-linkmode",LinkMode,@|
    NULL};
#endif

#ifdef USE_MATHLINK
MLINK MLinkPtr;
MLEnvironment MLEnv;
char MathTeXString[TeXFormBufferSize];
#endif

@ Open the connection to \Math.
@d WaitLoop  100000L
@<Open the connection to \Math@>=
void OpenConnectionToMath(void)
{ long int i,k;

  MLEnv=MLInitialize((MLParametersPointer) NULL);
  if(MLEnv==NULL) {
    ErrorMessage(NONCRITICAL,"OpenConnectionToMath",
       "Can't initialise MathLink.");
    CallMathematica=False;
    return;
   }
  MLinkPtr=MLOpen(MathArgc,MathArgv);
  if(MLinkPtr==NULL) {
    ErrorMessage(NONCRITICAL,"OpenConnectionToMath",
      "Can't open MathLink.");
    CallMathematica=False;
    return;
   }
#if !defined(WINDOWS_MATHLINK)   & !defined(OS2_MATHLINK)
  k=0;
  while(!MLReady(MLinkPtr)&& k<100) {
    for(i=0; i<WaitLoop; i++);
    k++;
    fprintf(stderr,"Waiting for MLink.\n");
   }
  if(!MLConnect(MLinkPtr))
    ErrorMessage(NONCRITICAL,"OpenConnectionToMath",
      "Can't get a connection.");
#endif
  printf("Connection to Mathematica : ");
  for(i=0; i<MathArgc; i++)
    printf("%s ",MathArgv[i]);
  printf("\n");
}

@ Close the \ML\ connection.
@<Close the communication with \Math@>=
void CloseConnectionToMath(void)
{
  if(!CallMathematica) return;
  MLPutFunction(MLinkPtr,"Exit",0L); /* quit the kernel */
  MLEndPacket(MLinkPtr);
  if(MLinkPtr) MLClose(MLinkPtr);
  if(MLEnv) MLDeinitialize(MLEnv);
}


@ @<Send a string to \Math\  and keep the \.{TeXForm}@>=
int ConvertMathStringToTeX(char *minput)
{ int pk;
  char *texstr;
  char *s1,*s2;

  if(STRSTR(minput,NoInputForm)) return False;
  while(s1=strchr(minput,'\\')) /* remove the line continuation from |minput| */
         memmove(s1,s1+1,strlen(s1));
  *MathTeXString='\0';
  fprintf(TeXFile,"%% Transfer to Mathematica\n"@|
                                                "%% %s\n",minput);
  MLPutFunction(MLinkPtr,"EvaluatePacket",1L);
         MLPutFunction(MLinkPtr,"ToString",1L);
		MLPutFunction(MLinkPtr,"TeXForm",1L);
        MLPutFunction(MLinkPtr,"ToExpression",1L);
          MLPutString(MLinkPtr,minput);
  MLEndPacket(MLinkPtr); /* this is obsolent but make it more clear */
  MLFlush(MLinkPtr);
#ifdef WINDOWS_MATHLINK
  while(!MLReady(MLinkPtr)) {
    Sleep(1000);
   }
#endif
  while((pk=MLNextPacket(MLinkPtr)) != RETURNPKT) {
    switch(pk) {
      case MESSAGEPKT :
        MLGetSymbol(MLinkPtr,&s1);
	MLGetString(MLinkPtr,&s2);
        printf("%% Message %s :: %s \n",s1,s2);
        fprintf(TeXFile,"%% Message %s :: %s \n",s1,s2);
        MLDisownSymbol(MLinkPtr,s1);
        MLDisownString(MLinkPtr,s2);
        break;
      case TEXTPKT :
        MLGetString(MLinkPtr,&s1);
        printf("%% Text: %s",s1);
        fprintf(TeXFile,"%% Text: %s",s1);
        MLDisownString(MLinkPtr,s1);
        break;
      case OUTPUTNAMEPKT:
      case RETURNTEXTPKT:
	MLGetString(MLinkPtr,&s1);
        fprintf(TeXFile,"%% %s\n",s1);
        fprintf(TeXFile,"%% %s\n",s1);
        MLDisownString(MLinkPtr,s1);
        break;
    }
   if(MLError(MLinkPtr)!=MLEOK || !pk) {
     ErrorMessage(NONCRITICAL,"ConvertMathStringToTeX"
       "MathLink error %s.",MLErrorMessage(MLinkPtr));
     if(MLError(MLinkPtr)==MLEDEAD || MLError(MLinkPtr)==MLECLOSED) {
       CallMathematica=False;
       return False;
      }
     MLClearError(MLinkPtr);
     }
   MLNewPacket(MLinkPtr);
  }

  if(MLGetType(MLinkPtr)==MLTKSTR && MLGetString(MLinkPtr,&texstr)) {
    strncpy(MathTeXString,texstr,TeXFormBufferSize);
    MLDisownString(MLinkPtr,texstr);
   }
  return True;
}

@* PostScript figures.

@ The |PSPrologFile| store the PostScript prolog for \Math\ 2.2
PostScript. This file here is simply the extracted form of a saved
picture but the lines |"/Mwidth ..."|, |"/Mheight .."| and
|"/Mnodistort .."| where removed.
The  default prefix for the extracted PostScript-files is set
to \.{pic} and the files will be named as
|"pic0.ps"|, |"pic1.ps"|, $\ldots$

@<Global values@>=
char PSPrologFile[MaxNameLength]="mathps.pro";

char PSFilePrefix[MaxNameLength]="pic";
int PSPicCount=0;
char PSFileName[MaxNameLength]="";
FILE *PSFile=NULL;

@ The width of the picture and its height, this values are unique
to all pictures in the notebook.
@<Global values@>=
double PSPicWidth=322.0;
double PSPicHeight=200.0;
double PSAspect=1.0;
int PSPreserveAspect=True;

@ The correct aspect ratio is extracted and used to calculate the
height of the Picture.
@d BeginAspectRatio  "AspectRatio"
@<Find the aspect ratio@>=
{ char *basp;

  basp=STRSTR(buffer,BeginAspectRatio);
  if(basp) {
    sscanf(basp,BeginAspectRatio ": %lg",&PSAspect);
    if(PSPreserveAspect)
      PSPicHeight=PSAspect*PSPicWidth;
   }
  else
    PSAspect=1.0;
 }

@ The prolog file must be located in the directory were the
program is. If no \.{-pspro} switch is given we get the full
path of the program (its name must be |PROGNAME|) than we find the
last position of |PROGNAME| in the full expanded path and replace the
program name by the name of the |PSPrologFile|.
Here is a short list of the difficulties:

\item{-} the program may have the name \.{mnb2ltx} (Unix) or
         \.{mnb2ltx.exe} (MS-DOS or OS/2)
\item{-} the program may be in a directory \.{/home/mnb2ltx/mnb2ltx}
\item{-} the directory names may be case sensitive.

That the steps below work the program must have a name starting with
\.{mnb2ltx}.

@<Search for PostScript prolog@>=
if (!CmdArgGiven("pspro",cmdln)) {
  char tmp[MaxNameLength],*c1,*c2,*c3;

  c1=tmp;
  c2=argv[0];
  while(*c2) /* convert all characters to lower case */
    *(c1++)=tolower(*(c2++));
  *c1='\0';
  /* search for the last position of the program name */
  c1=tmp;
  while(c2=STRSTR(c1,PROGNAME)) {
    c3=c2;
    c1=c2+1;
   }
  *c3='\0'; /* cut the string */
  c1=tmp;
  c2=argv[0];
  /* when the last position of the program name is found the case of the
  letters in the path are copyed back */
  while(*c1)
    *(c1++)=*(c2++);
  strcat(tmp,PSPrologFile); /* append the name of the prolog file */
  strcpy(PSPrologFile,tmp); /* copy the full path back */
 }

@ @<Open the PostScript file and write the preamble@>=
sprintf(PSFileName,"%s%d.ps",PSFilePrefix,PSPicCount++);
printf("Saving picture %s\n",PSFileName);
@<Find the aspect ratio@>@;
PSFile=fopen(PSFileName,"w");
if(!PSFile)
  ErrorMessage(CRITICAL,"ConvertCellToLaTeX",
         "Can't open PostScript file %s.",PSFileName);
fprintf(PSFile,@|
  "%%!PS-Adobe-2.0 EPSF-2.0\n"@|
  "%%%%BoundingBox: 0 0 %.0f %.0f\n"@|
  "%%%%Title: %s\n"@|
  "%%%%Creator: mnb2ltx " VERSION @|
  "\n%%%%CreationDate: \n"@|
  "%%%%EndComments\n"
  "%% File extracted from Mathematica Notebook :%s\n"@|
  "%% File is used by TeX document : %s\n",@|
  PSPicWidth,PSPicHeight,PSFileName,NotebookName,TeXFileName);
fprintf(PSFile,@|
  "%%%%BeginProcSet: %s\n",PSPrologFile);
fprintf(PSFile,@|
  "/Mathdict 150 dict def\n"
  "Mathdict begin\n"@|
  "/Mwidth  %.2f def\n"@|
  "/Mheight %.2f def\n"@|
  "/Mnodistort %s def\n",PSPicWidth,PSPicHeight,@|
    (PSPreserveAspect ? "true" : "false"));
 @<Copy the PostScript prolog file to the picture@>@;

@ @<Copy the PostScript prolog file to the picture@>=
{ FILE *pfile;
  char *buffer;
  size_t fsize;

  pfile=fopen(PSPrologFile,"r");
  if(!pfile)
    ErrorMessage(CRITICAL,"ConvertCellToLaTeX",
                "Can't find prolog file \"%s\" for picture \"%s\".",
      PSPrologFile,PSFileName);
  fsize=N2L_GetFileSize(pfile);
  buffer=(char *)malloc(fsize*sizeof(char));
  fsize=fread(buffer,sizeof(char),fsize,pfile);
  fwrite(buffer,sizeof(char),fsize,PSFile);
  free(buffer);
  fclose(pfile);
}

@ @d MathPSEnd "MathPictureEnd"
@<Copy PostScript from notebook to file@>=
pos=STRSTR(buffer,MathPSEnd);
while(buffer!=pos) {
  fputc(*(buffer++),PSFile);
  BufferPos++;
 }

@ @<Close PostScript file@>=
fprintf(PSFile,"%s\nend\nshowpage\n",MathPSEnd);
fclose(PSFile);

@* Writing the output file.
@<Global values@>=
char TeXProlog1[]=@|
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n"@|
"%% Mathematica Notebook -> LaTeX2e\n"@|
"%% " VERSION " from " __DATE__ "\n"
"%% (c) 1995, J.-P. Kuska\n"@|
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n";
char TeXProlog2[]=@|
"\\documentclass{article}\n"@|
"%%\n"
"\\usepackage{mathnb} %% notebook layout \n"@|
"%%%% Notebook text starts here\n"@|
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n"@|
"\\begin{document}\n\n";

const char TeXEpilog[]=
"%%%% End of Notebook\n"
"\\end{document}\n";

@ @<Generate default \TeX-file name@>=
{ char *posex,*tn,*nn;

  posex=STRSTR(NotebookName,NBExtension);
  tn=TeXFileName;
  nn=NotebookName;
  while(nn!=posex)   /* copy the notebook name with out the extension */
    *(tn++)=*(nn++);
  *tn='\0';
  strcat(TeXFileName,".tex");
}

@ @<Open the \LaTeX-file@>=
TeXFile=fopen(TeXFileName,"w");
if(!TeXFile)
  ErrorMessage(CRITICAL,"main",
    "Can't open output file \"%s\".",TeXFileName);
fprintf(TeXFile,TeXProlog1,PSPrologFile);
fprintf(TeXFile,"%% the document was generated by the command line:\n"@|
                "%% mnb2ltx ");
for(i=1;i<argc; i++)
  fprintf(TeXFile," %s ",argv[i]);
fprintf(TeXFile,"\n");
fprintf(TeXFile,TeXProlog2,PSPrologFile);
fprintf(TeXFile,"\\setlength{\\MathPicX}{%lg bp}\n",PSPicWidth);


@ @<Close \LaTeX-file@>=
fprintf(TeXFile,"%s",TeXEpilog);
fclose(TeXFile);

@ If the last input line was \.{TeXForm[]} no information about this
is included in the notebook, so we save the last input line in an global
value.
@<Global values@>=
char *LastInputLine=NULL;

@ When we call \Math\ we have to detect question marks, the \Math-symbols
in the online information can not translated to \TeX.
@<Check last input line for a question@>=
int CheckQuestionMark(register char *lastinput)
{
  lastinput=TrimString(lastinput);
  if(*lastinput=='?') return True;
  return False;
}


@ We need the last input line for testing, if it contains the
expression \.{TeXForm[any]} or \.{any // TeXForm} both cases must
be checked.
@<Check input for \.{TeXForm}@>=
int CheckTeXForm(register char *lastinput)
{ register char *p1;

  lastinput=TrimString(lastinput);
  if(STRSTR(lastinput,"TeXForm[")==lastinput)
	 return True;
  if(STRSTR(lastinput,"TeXForm [")==lastinput)
	 return True;
  if(STRSTR(lastinput,"TeXForm @@")==lastinput)
	 return True;
  if(STRSTR(lastinput,"TeXForm@@")==lastinput)
         return True;
  if((STRSTR(lastinput,"//")) && (STRSTR(lastinput,"TeXForm"))) {
         p1=strrchr(lastinput,'/')-1; /* find the last postfix */
         return (STRSTR(lastinput,"// TeXForm")==p1 ||
		 STRSTR(lastinput,"//TeXForm")==p1);
	}
  return False;
}

@ This function will do the main task of conversion. |pos| is used
to mark the end of the cell contens. |posverb| is used to
indicate the position of the |";[o]\n"| string, this string starts
the normal two dimensional output of \Math. The string |MathInput|
is keept to hold the original \.{InputForm} of the output.
@d Special_alltt  "{}\\"
@d Special_TeX    "{}\\#&^_$<>|"
@d BeginOut2D     ";[o]\n"
@d BeginFontSet   ";[s]\n"

@<Convert the cell contens to \LaTeX@>=
int  ConvertCellToLaTeX(int ctype)
{ register char  *buffer, *pos;
  char  *posverb, *mi,  *buffer1, *pfnt=NULL;
  const char TeXEsc='\\';
  char  *MathInput;
  int len, endofnotebook=False;
  int OutputIsTeX=False;

#if defined(WINDOWS_MATHLINK)
  if(CallMathematica)
    Sleep(100);
#endif
  @<Set |buffer| to cell contens and find the end of the cell@>@;
  switch(ctype+1) {
    case CellText       :
    case CellSmallText  :
      pfnt=STRSTR(buffer,BeginFontSet);
      fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
      @<Convert the cell to \TeX\  due to |TranslationType|@>@;
      fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
      break;
    case CellInput      :
      if (InitialInCell(buffer)) {
        ctype=CellMathInitial-1;
        buffer+=3;    /* skip over the end of comment |"*)\n"| */
        BufferPos+=3;
        pos=STRSTR(buffer,(char * ) MathCommentOpen); /* reset the end of the cell */
       }
      fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
      @<Write input cell contens@>@;
      fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
      break;
    case CellOutput     :
      if(!CallMathematica || !CheckQuestionMark(LastInputLine)) {
	if((OutputIsTeX=CheckTeXForm(LastInputLine)) || CallMathematica)
	  ctype=CellMathMath-1;
	fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
	@<Write output cell contens@>@;
	fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
	break;
       }
      else {
	ctype=CellPrint-1;
	goto NoMathTranslation;
       }
   case CellMessage    :
   case CellPrint      :
   case CellInformation :
     NoMathTranslation: pfnt=STRSTR(buffer,BeginFontSet);
     fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
     @<Write print/message cell contens@>@;
     fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
     break;

   case CellPostScript :
     if(buffer==pos) {
       BufferPos--;
       break;
      }
     while(isspace(*buffer) && buffer!=pos) {
       buffer++;
       BufferPos++;
      }
     if(buffer==pos) break;
     fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
     @<Open the PostScript file and write the preamble@>@;
     @<Copy PostScript from notebook to file@>@;
     fprintf(TeXFile,"\\includegraphics[width=\\MathPicX]{%s}\n",PSFileName);
     @<Close PostScript file@>@;
     fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
     break;
   case CellGraphics   : break;
   default:
      pfnt=STRSTR(buffer,BeginFontSet);
      switch(*CellTypes[ctype].TranslationType) {
	 case 'r' :
	 case 'R' :
		fprintf(TeXFile,"%% Cell convertet with replacement.\n");
	   break;
         case 'a' :
         case 'A' :
                fprintf(TeXFile,"%% Cell convertet for alltt-evironment.\n");
           break;
         case 'c' :
         case 'C' :
                fprintf(TeXFile,"%% Cell contens is copyed.\n");
                break;
        }
      fprintf(TeXFile,"%s",CellTypes[ctype].TeXProlog);
      @<Convert the cell to \TeX\  due to |TranslationType|@>@;
      fprintf(TeXFile,"%s",CellTypes[ctype].TeXEpilog);
   }
  return endofnotebook;
}

@ We have to look for special \TeX\  characters in the cell
contens here, if there is one found we preceed it by  the
|TeXEsc| character.

@<Verbatim output of cell contens@>=
if(pos) {
  while(buffer!=pos && buffer!=EndBuffer && buffer!=pfnt) {
    BufferPos++;
     if(strchr(Special_TeX,*buffer)) {
       @<Write \TeX-special characters for text@>@;
                 continue;
     }
         fputc(*(buffer++),TeXFile);
   }
 }

@ @<Write \TeX-special characters for text@>=
switch(*buffer) {
  case '\\' :
    fprintf(TeXFile,"$\\backslash$");
         break;
  case '^' :
         fprintf(TeXFile,"{\\^{}}");
    break;
  case '<' :
    fprintf(TeXFile,"$<$");
    break;
  case '>' :
         fprintf(TeXFile,"$>$");
    break;
  default :
    fprintf(TeXFile,"%c%c{}",TeXEsc,*buffer);
         break;
}
buffer++;


@ Copy the cell contens as it is with out any replacement.

@<Copy cell contens@>=
if(pos) {
  while(buffer!=pos && buffer!=EndBuffer && buffer!=pfnt) {
         BufferPos++;
    fputc(*(buffer++),TeXFile);
   }
 }

@ @<Convert the cell to \TeX\  due to |TranslationType|@>=
switch(*CellTypes[ctype].TranslationType) {
   case 'a'  :
        case 'A'  :
     @<Copy |buffer| to the \TeX-file and replace the \.{alltt}-characters@>@;
          break;
   case 'c'  :
   case 'C'  :
     @<Copy cell contens@>@;
          break;
   case 'r'  :
   case 'R'  :
     @<Verbatim output of cell contens@>@;
          break;
   default:
          ErrorMessage(NONCRITICAL,"ConvertCellToLaTeX",@|
       "Can't figure out how to translate the characters in cell type %s.",
       CellTypes[ctype].NBKey);
     @<Copy cell contens@>@;
     break;
 }

@ @<Set |buffer| to cell contens and find the end of the cell@>=
buffer=InputBuffer+BufferPos;
pos=STRSTR(buffer,BeginCellDescriptor);
if(!pos) {
  pos=STRSTR(buffer,"\n"EndNotebook);
  endofnotebook=True;
 }
if(!pos) {
  ErrorMessage(NONCRITICAL,"ConvertCellToLaTeX",
    "Can't find end of the Notebook.\n"@|
    "Notebook probably broken.\n");
  return True;
 }

@ It is assumed, that the input cell are typesetted by the \.{alltt}
environment an only braces $\{\}$ and backslashes must replaced.

@<Write input cell contens@>=
if(pos) {
  buffer1=buffer;
  len=0;
  while(buffer!=pos && buffer!=EndBuffer) {
    BufferPos++;
         len++;
    @<Character replacement ...@>@;
    fputc(*(buffer++),TeXFile);
        }
  if(LastInputLine) free(LastInputLine);
  LastInputLine=(char *)malloc((len+1)*sizeof(char));
  while(isspace(*buffer1)) buffer1++;
  len=0;
  while(buffer1!=pos && buffer1!=EndBuffer)
    LastInputLine[len++]=*(buffer1++);
  LastInputLine[len]='\0';
 }

@ Replace the special characters of the \.{alltt} environment.
@<Character replacement and |continue|@>=
    if(*buffer=='{' || *buffer=='}') {
      fprintf(TeXFile,"\\%c",*(buffer++));
                continue;
          }
    if(*buffer=='\\') {
                fprintf(TeXFile,"\\(\\backslash\\)");
      buffer++;
      continue;
     }


@ @d NoInputForm "No Input Form"

@<Write output cell contens@>=
posverb=STRSTR(buffer,(char  *)BeginOut2D);
len=0;
while(buffer+len!=posverb)
  len++;
mi=MathInput=(char *)malloc((len+1)*sizeof(char));
while(isspace(*buffer)) {
  buffer++;
  BufferPos++;
 }
while(buffer!=posverb) { /* copy the \.{InputForm} to |MathInput|*/
  *(mi++)=*(buffer++);
  BufferPos++;
 }
*mi='\0';
while(isspace(*(mi-1)) || isspace(*mi))
  *(mi--) ='\0';
TrimString(MathInput);
buffer+=strlen(BeginOut2D);   /* skip over the 2d output indicator */
BufferPos+=strlen(BeginOut2D);
#ifdef USE_MATHLINK
if(OutputIsTeX) {
  while(buffer!=pos && buffer!=EndBuffer) {
    BufferPos++;
    fputc(*(buffer++),TeXFile);
  }
 }
else if(CallMathematica && ConvertMathStringToTeX(MathInput)) {
  fprintf(TeXFile,"%s",MathTeXString);
  while(buffer!=pos && buffer!=EndBuffer) { /* skip over the buffer */
    buffer++;
    BufferPos++;
   }
 }
else {
  if (CallMathematica && !STRSTR(MathInput,NoInputForm))
    ErrorMessage(NONCRITICAL,"ConvertCellToLaTeX",@|
                "%%Something wrong calling Mathematica with:\n%s\n"@|
                "%%TeX will probably have some trouble here.",MathInput);
  @<Write the contens of output-cell to the file@>@;
 }
#else
while('\n'==*EndBuffer)
  EndBuffer--;
@<Write the contens of output-cell to the file@>@;
#endif
free(MathInput);

@ @<Write the contens of output-cell to the file@>=
if(OutputIsTeX) {
  while(buffer!=pos && buffer!=EndBuffer) {
    BufferPos++;
    fputc(*(buffer++),TeXFile);
  }
 }
else {
  @<Copy |buffer| to the \TeX-file and replace ...@>@;
 }

@ @<Copy |buffer| to the \TeX-file and replace the \.{alltt}-characters@>=
while(buffer!=pos && buffer!=EndBuffer) {
  BufferPos++;
  @<Character replacement ...@>@;
  fputc(*(buffer++),TeXFile);
 }

@ @<Write print/message cell contens@>=
posverb=STRSTR(buffer,BeginOut2D);
if(posverb && PtrLess(buffer,posverb,pos)) {
  while(buffer!=posverb) { /* skip over the \.{InputForm} */
    buffer++;
    BufferPos++;
   }
  buffer+=strlen(BeginOut2D);   /* skip over the 2d output indicator */
  BufferPos+=strlen(BeginOut2D);
 }
if(buffer!=pos) { /* write the remaining output to the file */
  @<Copy |buffer| to the \TeX-file and replace ...@>@;
 }

@ @<Exit function@>=
void ExitNotebook2TeX(void)
{
#ifdef USE_MATHLINK
  if(CallMathematica)
    CloseConnectionToMath();
#endif
  if(TeXFile) fclose(TeXFile);
}

@*Main.
@<Main@>=
int main(int argc, char *argv[]){
  CmdArgLst *cmdln;
  char celldescr[MaxNameLength];
  int endnb,i;
  int cellType;

  atexit(ExitNotebook2TeX);
  @<Declare the comand line options@>@;
  if (argc>1)
    cmdln=ScanCommandline(cmdln,argc,argv);
  if(argc<=1 || !(*NotebookName)) {
    HelpCmdArg(BANNER,cmdln);
    exit(1);
   }
  @<Update replacement for text cells@>@;
  @<Search for PostScript prolog@>@;
  printf(BANNER);
  if(!STRSTR(NotebookName,NBExtension)) strcat(NotebookName,NBExtension);
  if(!*TeXFileName) @<Generate default \TeX-file name@>@;
  NBFile=fopen(NotebookName,"rt");
  if(!NBFile)
    ErrorMessage(CRITICAL,"main",
                "Can't find notebook \"%s\".",NotebookName);
  @<Open the \LaTeX-file@>@;
  @<Fill the input buffer@>@;
  printf("Converting file \"%s\" -> \"%s\"\n",NotebookName,TeXFileName);
#ifdef USE_MATHLINK
  if(CallMathematica)
     OpenConnectionToMath();
#endif
  while(FindCellDescriptor(celldescr) && BufferPos<BufferSize) {
    cellType=FindCellType(celldescr);
    if(cellType>-1 && !EmptyCell()) {
      endnb=ConvertCellToLaTeX(cellType);
      fflush(TeXFile);
     }
    if(endnb) break;
   }
  @<Close \LaTeX-file@>@;
  @<Free input buffer@>@;
#ifdef USE_MATHLINK
  if(CallMathematica) {
    CloseConnectionToMath();
    CallMathematica=False;
   }
#endif
  return 0;
}


@ @<Header@>=
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>
#include <stdarg.h>
#include <fcntl.h>
#ifdef __GNUC__
#include <sys/types.h>
#endif
#include <sys/stat.h>
#ifdef USE_MATHLINK
#define P(s) s
#include "mathlink.h"
#endif
#pragma hdrstop
#include "cmdln.h"
#ifdef __WATCOMC__
#include <malloc.h>
#endif
@* Index.
